var offline = false;

function onLoad(){
	app.initialize();
}

function onResume(){
	/*window.plugin.notification.local.onclick = function (id, state, json) {		
		gotoConsiglio(json);
	};*/
	/*setTimeout(function(){
		console.log("resume");
		
	},0);*/
	app.onDeviceReady();
}

function onPause(){
	window.localStorage.setItem('prima_volta', 'false');
	/*console.log("============================================ ON PAUSE");
    window.localStorage.setItem('data_ultimo_aggiornamento', getDataOra(-1));
	window.localStorage.setItem('data_primo_accesso_del_giorno', getDataOra(-1));*/
}

function onOffline(){
	console.log("onoffline");
	if (!offline) {
		offline = true;
		$(document).toggleSticky('#error');
	}
}

function onOnline(){
	console.log("ononline");
	if (offline) {
		offline = false;
		$(document).toggleSticky('#error');
	}
}

function onBackbutton(e){
	console.log("backbutton");
	e.preventDefault();
}

var risveglio_da_notifica = false;

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    
    // Bind Event Listeners
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
		preload_wait();
		  
        if ( !navigator.userAgent.match(/Android/i) ) {
		if (window.plugin.notification.local.hasPermission) {
			window.plugin.notification.local.hasPermission(function(granted) {
				if (!granted) {
					window.plugin.notification.local.promptForPermission();
				}
			});
		}
		}
        
        document.addEventListener('pause', onPause, false);        
        document.addEventListener('resume', onResume, false);
        document.addEventListener('offline', onOffline, false);
        document.addEventListener('online', onOnline, false);
        document.addEventListener('backbutton', onBackbutton, false );
       /* if( navigator.userAgent.match(/Android/i) ) {
			console.log("android");
			document.addEventListener( "mouseenter", function(e){ e.preventDefault(); } , false );
		}*/
        
        if (navigator.splashscreen)
			setTimeout(function() {navigator.splashscreen.hide(); }, 3000);
		
		window.plugin.notification.local.setDefaults({ autoCancel: true });
		window.plugin.notification.local.onclick = function (id, state, json) {
			getDatiUtenteOggi();
			refreshValoriInGrafica();
			var json = $.parseJSON(json);
			console.log('RISVEGLIO DA NOTIFICA: '+json.tipo);
			risveglio_da_notifica = (json.tipo == undefined) ? true : json.tipo;
		};

		console.log(' ======================= stato iniziale ==================== ');
		console.log('prima-volta: '+window.localStorage.getItem('prima_volta'));
		console.log('data_ultimo_aggiornamento: '+window.localStorage.getItem('data_ultimo_aggiornamento'));
		console.log('data_primo_accesso_del_giorno: '+window.localStorage.getItem('data_primo_accesso_del_giorno'));
		console.log('username: '+window.localStorage.getItem('username'));
		console.log('id_percorso: '+window.localStorage.getItem('id_percorso'));
		console.log('risveglio da notifica: '+risveglio_da_notifica);
		
		if (risveglio_da_notifica) {
			if (risveglio_da_notifica == 'reminder') {
			  permanentStorage.removeItem('reminder_ora');
			  permanentStorage.removeItem('reminder_minuti');
			  permanentStorage.removeItem('reminder_id');
			  $("#tip-today-icon-clock").hide();
			}
			else if (risveglio_da_notifica ==  'ricorda_consiglio') {
			  permanentStorage.removeItem('ricorda_consiglio_id');
			}
		}
		
		if (window.localStorage.getItem('prima_volta')=='false') {
			$('#layer-login-intro').remove();
		}
		window.localStorage.setItem('prima_volta', 'false');
		
		if (window.localStorage.getItem('username')===null || window.localStorage.getItem('username')==null || window.localStorage.getItem('username')=='null') {
			console.log('caso login');
			$('#layout-launch').attr('data-click-to-selector', '#layout-login');
			
			$('#layout-launch').trigger('click');
		}
		else if (window.localStorage.getItem('id_percorso')==null || window.localStorage.getItem('id_percorso')=='null' || window.localStorage.getItem('id_percorso')===null) {
			console.log('caso nuovo percorso');
			gotoNuovoPercorso();
		}
		else if (window.localStorage.getItem('data_ultimo_aggiornamento') && date_sub(getDataOra(0), window.localStorage.getItem('data_ultimo_aggiornamento')) > 0 ) {
			console.log('ultimo refresh dei dati di ieri '+window.localStorage.getItem('data_ultimo_aggiornamento'));
			getDatiUtenteOggi();
			
			window.localStorage.setItem('data_ultimo_aggiornamento', getDataOra(0));
			
			// se non c'è più un percorso vado in layer-login-percorso altrimenti in layer-home
			if (window.localStorage.getItem('id_percorso')==null || window.localStorage.getItem('id_percorso')=='null' || window.localStorage.getItem('id_percorso')===null) {
				gotoNuovoPercorso();
			}
			else {
				refreshValoriInGrafica();
				
				$('.layout.active').removeClass('active');
				$('.page.active').removeClass('active');
				$('.layer.active').removeClass('active');

				$('#layout-home').addClass('active');
				$('#page-home').addClass('active');
				$('#layer-home-start').addClass('active');
				
				/*if (risveglio_da_notifica && !is_tip_selected) {
					risveglio_da_notifica = false;
					$(document).gotoElement('#layer-home-tip', '', '', true);
				}
				else*/
				isPrimoAccesso();
			}
		}
		else if (permanentStorage.getItem('cinque_consigli')===null) {
			//non faccio nulla, sono in registrazione
		}
		else {// in questo caso ci sono già tutti i dati utente aggiornati
			console.log('caso loggato');
			
			var layout_attivo = $('.layout.active');
			
			if (layout_attivo.size() == 0) {
				layout_attivo = '#layout-home';
			}
			else if (layout_attivo.size() == 1) {
				layout_attivo = '#'+layout_attivo.attr('id');
			}
			else {
				$('.layout.active').removeClass('active');
				$('.page.active').removeClass('active');
				$('.layer.active').removeClass('active');
				$('#layout-launch').addClass('active');
				layout_attivo = '#layout-home';
			}
			
			console.log('GOTO: '+layout_attivo);
			
			$('#layout-launch').attr('data-click-to-selector', '#layout-home');
			refreshValoriInGrafica();
			$('#layout-launch').trigger('click');
            
         /*   if (risveglio_da_notifica && !is_tip_selected) {
				risveglio_da_notifica = false;
				$(document).gotoElement('#layer-home-tip', '', '', true);
			}
			else*/
			isPrimoAccesso();
		}
		
		risveglio_da_notifica = false;
	}
};
