var baseurl            = "http://demou.seisnet.it/nzg/star/";
var consiglio          = null;
var consigli5_stampati = false;
var attivita_stampate  = false;
var permanentStorage   = window.localStorage;

function registrazioneForm() {
	$.ajax( baseurl+"registrati.php"+"?"+getTokenString(), {
	  type: 'GET',
		cache: false,
		async: false,
	}).done(function(risp) {
		risp = $.parseJSON(risp);
		data = risp.form;
		$("#divFormRegistrazione").html(data);
		aggiornaLinkLista();
		$(document).gotoElement('#layer-login-register');
	});
}

function recuperaPasswordForm() {
  $.ajax( baseurl+"recuperapassword.php"+"?"+getTokenString(), {
    type: 'GET',
    cache: false,
    async: false,
  }).done(function(risp) {
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    data = risp.form;
    $("#divFormRecuperaPassword").html(data);
    aggiornaLinkLista();
  });
}

function strpad(str, length, c) {
    var ris = ""+str;
    while (ris.length < length)
        ris = c + ris;
    return ris;
}
function schedulazioneNotificheConsigli() {
  var notifiche_consigli = $.parseJSON(permanentStorage.getItem('consigli_da_schedulare'));
  if(notifiche_consigli.toString() != 'null' && notifiche_consigli.length > 0) {
    if(!window.plugin.notification.local.hasPermission())
      window.plugin.notification.local.promptForPermission();
    var minuti = new Date().getMinutes();
    var ore = new Date().getHours();
    var giorno = new Date().getDate();
    var mese = new Date().getMonth();
    var anno = new Date().getFullYear();
    $.each(notifiche_consigli, function(idx, v) {
        var adesso = new Date();
        var oggi = adesso.getFullYear()+"-"+strpad(1+adesso.getMonth(), 2, "0")+"-"+strpad(adesso.getDate(), 2, "0");
        if (oggi == v['data']) {
          var ora_notifica = new Date(v['data']+" "+v['ora']);
          if (ora_notifica.getTime() < adesso.getTime())
            data = oggi + " " + adesso.getHours()+":"+adesso.getMinutes()+":"+adesso.getSeconds();
          else
            data = oggi + " "+ v['ora'];
        }
        else
          data = v['data']+" "+v['ora'];

        console.log(""+idx+": "+v['data']+" "+oggi+" "+data);
        if(minuti >= 60) {
          minuti = 0;
          ore++;
        }
        if(ore >= 24) {
          ore = 0;
          giorno++;
        }

        data_mia=new Date();
        data_mia.setFullYear(anno,mese,giorno);
        data_mia.setHours(ore);
        data_mia.setMinutes(minuti);

        minuti=minuti+1;
        data_mia.setSeconds(00);
        //alert("id: "+v['id']+" consiglio: "+v['consiglio']+" data:"+data_mia.toString());
        window.plugin.notification.local.add({
            id:      v['id'],
            title:   'Star: consiglio del giorno',
            message: v['consiglio'],
            date:   data_mia,
            json: JSON.stringify({ 'id':v['id'], 'consiglio': v['consiglio'], 'tipologia_consiglio': v['tipologia_consiglio'] })
        });

    });
    scaricaImmagineUtente();
  }
}

function recuperapassword() {
  $.ajax( baseurl+"recuperapassword.php"+"?"+getTokenString(), {
    type: 'POST',
    data: $('#formRecupera').serialize()+"&"+getTokenString(),
    cache: false,
    async: false,
  }).done(function(risp) {
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    data = risp.form;
    if(!successo && error != 'NON POST') {
      $('#error-login-password').html(error);
      $(document).gotoElement('#layer-login-password .panel-error');
      $("#divFormRecuperaPassword").html(data);
    }
    else {
      $('#error-login-password').html("La nuova password è stata inviata all'indirizzo email indicato");
      $(document).gotoElement('#layer-login-password .panel-error');
    }

    aggiornaLinkLista();
  });
}

function aggiornaLinkLista() {
  $('.click-to-element').off('click');
  $('.input-target-options a').off('click');

  bindClickToElement();
  bindInputTargetOptions();
}

function listaPercorsi() {
	console.log('listaPercorsi');
	var percorsi = $.parseJSON(permanentStorage.getItem('tipologie_percorso'));
  var righe = '';
  var flag_first = true;
  if(percorsi != null && permanentStorage.getItem("id_percorso").toString() == 'null') {
    $.each(percorsi, function(k, v) {
      righe += '<a class="list-group-item" href="index.html#" data-input-value="'+v['id']+'" onclick="$(\'#id_obiettivo\').val('+v['id']+');">'+v['descrizione']+' <span class="ion pull-right"></span></a>';
    });
  }
  else {
    $(document).gotoElement('#layout-home');
  }

  $('#percorsi').html(righe);
  aggiornaLinkLista();
  $(document).gotoElement("#layer-login-target-goal");
}

function salvaPercorsoRinuncia(id_rinuncia) {
  if(id_rinuncia) {
    $(document).gotoElement('#layout-home');
    permanentStorage.setItem("id_rinuncia", id_rinuncia);
    $.ajax( baseurl+"actions.php", {
      type: 'POST',
      data: 'action=saveprofilazione&username='+permanentStorage.getItem('username')+'&password='+permanentStorage.getItem('password')+'&idpercorso='+permanentStorage.getItem('id_obiettivo')+'&idrinuncia='+permanentStorage.getItem('id_rinuncia')+'&'+getTokenString(),
      cache: false,
      async: false,
    }).done(function(risp) {
      risp = $.parseJSON(risp);
      data = risp.data;
      if(risp.success) {
        permanentStorage.setItem("id_percorso", data['id_percorso']);
        permanentStorage.setItemp('consigli_da_schedulare', risp.data['consigli_da_schedulare']);
        schedulazioneNotificheConsigli();
      }
      
    });
  }
}

function listaRinunce(id_obiettivo) {
  console.log(id_obiettivo);
  if(id_obiettivo) {
    $(document).gotoElement('#layer-login-target-waiver');
    permanentStorage.setItem('id_obiettivo', id_obiettivo);
    //var percorsi = $.parseJSON(permanentStorage.getItem('tipologie_percorso'));
    var rinunce  = $.parseJSON(permanentStorage.getItem('tipologie_rinuncia'));
    var righe = '';
    var flag_first = true;

    if(rinunce) {
      $.each(rinunce, function(k, v) {
        righe += '<a class="list-group-item" href="index.html#" data-input-value="'+v['id']+'" onclick="$(\'#id_rinuncia\').val('+v['id']+');">'+v['descrizione']+' <span class="ion pull-right"></span></a>';
        if(flag_first) {
          flag_first = false;
        }
      });
    }
    $('#rinunce').html(righe);
    aggiornaLinkLista();
  }
}

function caricaFoto() {
  if(permanentStorage.getItem("username"))
    $(document).gotoElement('#layer-login-photo-confirm');
  //else
}

function registrati() {
  $.ajax(baseurl + "registrati.php",
  {
    type: 'POST',
    cache: false,
    async: false,
    data: $('#formRegistrazione').serialize()+"&"+getTokenString()
  })
  .done(function(risp) {
    risp     = $.parseJSON(risp);
    error    = risp.error;
    successo = risp.success;
    data     = risp.form;
    if(successo == true) {
      permanentStorage.setItem("id_percorso", data['id_percorso']);
      permanentStorage.setItem("username", data['username']);
      permanentStorage.setItem("cognome", data['cognome']);
      permanentStorage.setItem("nome", data['nome']);
      permanentStorage.setItem("password", $("#formRegistrazione #password").val());
      permanentStorage.setItem('tipologie_percorso', JSON.stringify(data['tipologie_percorso']));
      permanentStorage.setItem('tipologie_consiglio', JSON.stringify(data['tipologie_consiglio']));
      permanentStorage.setItem('tipologie_rinuncia', JSON.stringify(data['tipologie_rinuncia']));
      permanentStorage.setItem('tipologie_attivita', JSON.stringify(data['tipologie_attivita']));
      $(document).gotoElement('#layer-login-photo-upload');
    }
    else {
      $('#messaggio_errore_registrazione').html(error);
      $(document).gotoElement('#layer-login-register .panel-error');
      form = risp.form;
    }
  });
}

function loadRegistrazioneForm() {
  registrazioneForm();
}

function login(password) {
  $.ajax( baseurl + "actions.php",
  {
      type: 'POST',
      cache: false,
      async: false,
      data: $('#form_login').serialize()+"&"+getTokenString()
  })
  .done(function(risp) {
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    data = risp.data;

    if(successo == true) {
      permanentStorage.setItem('tipologie_percorso', JSON.stringify(data['tipologie_percorso']));
      permanentStorage.setItem('tipologie_consiglio', JSON.stringify(data['tipologie_consiglio']));
      permanentStorage.setItem('tipologie_rinuncia', JSON.stringify(data['tipologie_rinuncia']));
      permanentStorage.setItem('tipologie_attivita', JSON.stringify(data['tipologie_attivita']));
      permanentStorage.setItem('id_percorso', data['id_percorso']);
      permanentStorage.setItem('username', data['username']);
      permanentStorage.setItem('password', password);
      permanentStorage.setItem("cognome", data['cognome']);
      permanentStorage.setItem("nome", data['nome']);

      if(data['id_percorso'] != null) {
        permanentStorage.setItem('consigli_da_schedulare', JSON.stringify(data['consigli_da_schedulare']));
        $('#user-name').html('<a href="javascript: logOut();">'+data['nome']+'</a>');
        $(document).gotoElement('#layout-home', '', '', true, '', '');

        schedulazioneNotificheConsigli();
      }
      else {
        $(document).gotoElement('#layer-login-target-goal');
        listaPercorsi();
      }
    }
    else {
      $('#messaggio_errore_login').html(error);
      $(document).gotoElement('#layer-login-login', '', '', true, '', '');
    }
    form = risp.form;

  });

}

function getAttivita() {
  $.ajax( baseurl + "actions.php",
  {
      type: 'POST',
      cache: false,
      async: false,
      data: 'action=getlistaattivita&username='+permanentStorage.getItem('username')+'&password='+permanentStorage.getItem('password')+'&'+getTokenString(),
  })
  .done(function(risp) {
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    data = risp.data;
    permanentStorage.setItem('attivita_lista', JSON.stringify(data));

    if(successo == true) {
      stampaAttivita();
    }
  });
}

function stampaAttivita() {
  if(!attivita_stampate) {
  var att_str         = '';
  var categoria_count = 1;
  attivita_lista  = $.parseJSON(permanentStorage.getItem('attivita_lista'));
  tipologie_attivita = $.parseJSON(permanentStorage.getItem('tipologie_attivita'));

  $.each(attivita_lista, function(k, v) {
    att_str += '<div id="task-category-'+categoria_count.toString()+'" class="list-group task-category"><a href="index.html#task-category-'+categoria_count.toString()+'-items" class="group-content" data-toggle="collapse" data-parent="#task-items" aria-expanded="false" aria-controls="task-category-'+categoria_count.toString()+'-items"> <div class="group-arrow h2 pull-right"> <span class="ion ion-ios7-arrow-down"></span></div><h3>'+tipologie_attivita[k-1].descrizione+'</h3></a><div id="task-category-'+categoria_count.toString()+'-items" class="list-group-items collapse" aria-labelledby="task-category'+categoria_count.toString()+'">';
    var att_count = 1;

    $.each(v, function(k1, v1) {
      att_str += '<div id="list-item-'+att_count.toString()+'" class="list-item task task-category-'+att_count.toString()+'"><a href="index.html#" class="item-content" onclick="$(document).gotoElement(\'#layer-home-task\', \'\', \'\', true, gotoDettaglioAttivita('+k+', '+k1+'), null);"><div class="item-arrow h2 pull-right"><span class="ion ion-ios7-arrow-forward"></span></div><h4>Attività '+att_count.toString()+'                                            <span class="checkmark  ion ion-ios7-checkmark-outline"></span></h4><p>'+v1['attivita']+'</p></a></div>';
      att_count++;
    });

    att_str += '</div></div>';
    categoria_count++;
  });
  $('#task-items').html(att_str);
  aggiornaLinkLista();
  attivita_stampate = true;
  }
}

function gotoDettaglioAttivita(id_categoria_attivita, id_attivita) {
  attivita_lista  = $.parseJSON(permanentStorage.getItem('attivita_lista'));
  $('#attivita_selezionata_text').html(attivita_lista[id_categoria_attivita][id_attivita]['attivita']);
}

function get5Consigli() {
  $.ajax( baseurl + "actions.php",
  {
      type: 'POST',
      cache: false,
      async: false,
      data: 'action=index&username='+permanentStorage.getItem('username')+'&password='+permanentStorage.getItem('password')+'&'+getTokenString(),
  })
  .done(function(risp) {
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    data = risp.data;

    if(successo == true) {
      permanentStorage.setItem('cinque_consigli', JSON.stringify(data['cinque_consigli']));
      permanentStorage.setItem('storico', JSON.stringify(data['storico']));
      permanentStorage.setItem('dettaglio_oggi', data['dettaglio_oggi']);
      stampa5Consigli();
    }
  });
}

function stampa5Consigli() {
  if(!consigli5_stampati) {
  cinque_consigli = $.parseJSON(permanentStorage.getItem('cinque_consigli'));
  storico         = $.parseJSON(permanentStorage.getItem('storico'));
  dettaglio_oggi  = permanentStorage.getItem('dettaglio_oggi');

  $.each(storico, function(k, v){permanentStorage.setItem('data_inizio', v.data_inizio);});
      //permanentStorage.setItem('consigli', Date.UTC(Date.parse(new Date()) - Date.parse(permanentStorage.getItem('data_inizio'))));
      data_inizio = Date.parse(permanentStorage.getItem('data_inizio'));
      //window.alert(data_inizio);

      //5 consigli
      var consigli_5_str = '';
      var count = 1;
      var active = 'active';
      var vai_precedente = 'data-swipe-right-to-selector="#layer-home-start" data-swipe-right-to-animate-class-in="bounceInDown" data-swipe-right-to-animate-class-out="bounceOutRight"';
      $.each(cinque_consigli, function(k, v) {
        var category = 'tip-category-sport';
        switch(v['tipologia_consiglio']) {
          case '4':
            category = 'tip-category-sport';
          break;
          case '5':
            category = 'tip-category-food-drink';
          break;
          case '6':
            category = 'tip-category-good-habits';
          break;
        }
        var id = null;
        if(v['id'] != undefined)
          id = v['id'];
        else
          id = v['id_dettaglio'];
        consigli_5_str += '<div id="layer-home-tip-'+count.toString()+'" rel="'+id+'" class="tip '+active+' '+category+' swipe-to-element" data-swipe-left-to-selector="#layer-home-tip-'+(count+1).toString()+'" data-swipe-left-to-animate-class-in="bounceInDown" data-swipe-left-to-animate-class-out="bounceOutLeft"  '+vai_precedente+'><div class="tip-header"><a href="index.html#" class="tip-close pull-right click-to-element" data-click-to-selector="#layer-home-start"><span class="ion ion-close-round"></span></a></div><div class="tip-separator"></div><div class="tip-content"><h2>CONSIGLIO '+count.toString()+'</h2><p></p><p>'+v['consiglio']+'</p></div></div>';
        count++;
        active = '';
        vai_precedente = 'data-swipe-right-to-selector="#layer-home-tip-'+(count-1).toString()+'" data-swipe-right-to-animate-class-in="bounceInDown" data-swipe-right-to-animate-class-out="bounceOutRight"';
      });
      $('#content_tips').html(consigli_5_str);
      aggiornaLinkLista();
      consigli5_stampati = true;
    }
}

/*function gotoConsiglio(json) {
  var consiglio = $.parseJSON(json);
  var consiglio_str = '';
  var category = 'tip-category-sport';
  var id;
  switch(consiglio['tipologia_consiglio']) {
    case '4':
      category = 'tip-category-sport';
    break;
    case '5':
      category = 'tip-category-food-drink';
    break;
    case '6':
      category = 'tip-category-good-habits';
    break;
  }
  var id = consiglio['id'];

  consiglio_str += '<div id="layer-home-tip-1" rel="'+id+'" class="tip active '+category+' swipe-to-element" data-swipe-left-to-selector="#layer-home-tip-1" data-swipe-left-to-animate-class-in="bounceInDown" data-swipe-left-to-animate-class-out="bounceOutLeft"><div class="tip-header"><a href="index.html#" class="tip-close pull-right click-to-element" data-click-to-selector="#layer-home-start"><span class="ion ion-close-round"></span></a></div><div class="tip-separator"></div><div class="tip-content"><h2>CONSIGLIO DEL GIORNO</h2><p></p><p>'+consiglio['consiglio']+'</p></div></div>';

  $('#content_tips').html(consiglio_str);
  aggiornaLinkLista();
}*/


    
function logOut() {
	alert("Attendere, logout in corso.");
	window.localStorage.clear();
	window.plugin.notification.local.cancelAll();
	location.reload();
}



/* ================ caricamento foto profilo ================ */
function onPhotoChooseFail(message) {
	alert('Failed because: ' + message);
}

function onPhotoChooseSuccess(imageData) {
  var imgNascosta = document.getElementById('img_profile_nascosta');

  if (imageData.substring(0,4) != 'data')
	imageData = "data:image/jpeg;base64," + imageData;

  imgNascosta.src = imageData;
  var w_orig = $(imgNascosta).width();
  var h_orig = $(imgNascosta).height();
  console.log(w_orig+" x "+h_orig);
  
  if (w_orig*h_orig > 400000) {
	  var ratio = Math.sqrt(1.0*(w_orig*h_orig)/307200);		// la ridimensiono per avere il peso di una 640*480
	  var w_new = parseInt(w_orig/ratio);
	  var h_new = parseInt(h_orig/ratio);
	  console.log(ratio+" "+w_new+" "+h_new);
	  
	  var canvas = document.createElement("canvas");
	  canvas.width = $('#img_profile_nascosta').width();
	  canvas.height = $('#img_profile_nascosta').height();
	  console.log($('#img_profile_nascosta').width()+" "+$('#img_profile_nascosta').height());
	  var ctx = canvas.getContext("2d");
	  ctx.drawImage(imgNascosta,0,0);
	  ctx.scale(ratio, ratio);
	  
	  imageData = canvas.toDataURL("image/jpeg");
  }
  
  var smallImage = document.getElementById('img_profile');

  if (imageData.substring(0,4) != 'data')
	imageData = "data:image/jpeg;base64," + imageData;
  
  smallImage.src = imageData;
  
  $('#profile_hidden').val(imageData);
}

function getPhotoFromGallery() {
	navigator.camera.getPicture(onPhotoChooseSuccess, onPhotoChooseFail, {
		quality: 70,
		allowEdit: true,
		destinationType: navigator.camera.DestinationType.DATA_URL,			// FILE_URI, DATA_URL
		sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY			// PHOTOLIBRARY, SAVEDPHOTOALBUM
	});
}


function sendProfileImage(gotoNuovoPercorso) {
	var hidden = $('#profile_hidden').val();
	
	console.log("action=setprofileimage&username="+permanentStorage.getItem("username")+"&password="+permanentStorage.getItem("password")+"&image=xxx&"+getTokenString());
    $.ajax( baseurl+"actions.php", {
      type: 'POST',
      data: "action=setprofileimage&username="+permanentStorage.getItem("username")+"&password="+permanentStorage.getItem("password")+"&image="+encodeURIComponent($('#profile_hidden').val())+"&"+getTokenString(),
      cache: false,
      async: false,
    }).done(function(risp) {
      risp = $.parseJSON(risp);
      data = risp.data;
      if(!risp.success) {
          $(document).gotoPanel("#layer-login-photo-upload .panel-error");
      }
      else if (gotoNuovoPercorso) {
		  listaPercorsi();
		  $('#layer-login-target-goal').addClass("active");
		  $("#layer-login-photo-confirm").removeClass("active");
	  }
    });
}
/* ================ fine caricamento foto profilo ================ */


function scaricaImmagineUtente() {
	$.ajax( baseurl+"actions.php", {
      type: 'POST',
      data: "action=index&username="+permanentStorage.getItem("username")+"&password="+permanentStorage.getItem("password")+"&getprofileimage=true&"+getTokenString(),
      cache: false,
      async: false,
    }).done(function(risp) {
      risp = $.parseJSON(risp);
      data = risp.data;
      if(risp.success) {
		imageData = data['image'];
		
		if (imageData.length>4 && imageData.substring(0,4)!='data')
			imageData = "data:image/jpeg;base64," + imageData;
		
		permanentStorage.setItem("profileImage"+permanentStorage.getItem("id"), imageData);
		
		var userImage = document.getElementById("user-photo");
        userImage.setAttribute('src', imageData);
		
        console.log("blur image");
        
        setTimeout(function() { elaboraBluredUserBackground(); }, 1000);
      }
      
    });
}

function elaboraBluredUserBackground() {
	imageData = permanentStorage.getItem("profileImage"+permanentStorage.getItem("id"));
	$('#user-profile-hidden').css('background-image', 'url(' + imageData + ')');
	$('#user-profile').blurjs({ source: '#user-profile-hidden', radius: 64, overlay: 'rgba(255,255,255,0.6)' });
	permanentStorage.setItem("profileImageBlured"+permanentStorage.getItem("id"), $('#user-profile').css("background-image"));
}


function caricaImmaginiUtenteDaStorage() {
	if (permanentStorage.getItem("id")) {
		var id = permanentStorage.getItem("id");
		if (!permanentStorage.getItem("profileImage"+id) || !permanentStorage.getItem("profileImageBlured"+id)) {
			scaricaImmagineUtente();
		} else {
			var userImage = document.getElementById("user-photo");
			userImage.setAttribute('src', permanentStorage.getItem("profileImage"+id));
			$('#user-profile-hidden').css('background-image', 'url(' + permanentStorage.getItem("profileImageBlured"+id) + ')');
		}
	}
}
