var BADGE_SOCIAL = 0x01;
var BADGE_SKIP5TIPS = 0x02;
var BADGE_PROFILAZIONE = 0x04;
var BADGE_5_TIPS_INAROW = 0x08;
var BADGE_10_TIPS_INAROW = 0x10;
var BADGE_10_TIPS_C4 = 0x20;
var BADGE_10_TIPS_C6 = 0x40;
var BADGE_10_TIPS_C5 = 0x80;
var BADGE_FAIL = 0x100;			//256
var BADGE_FIRSTBLOOD = 0x200;
var BADGE_REMINDER = 0x400;		//1024
var BADGE_SPRINTFINALE = 0x800;
var BADGE_THEEND = 0x1000;
var BADGE_ALLTIPS = 0x2000;
var BADGE_ALLBADGES = 0x4000;
var BADGE_ACT_1_ALL = 0x8000;
var BADGE_ACT_2_ALL = 0x10000;
var BADGE_ACT_3_ALL = 0x20000;
var BADGE_ACT_4_ALL = 0x40000;
var BADGE_ACT_5_ALL = 0x80000;
var BADGE_ACT_6_ALL = 0x100000;
var BADGE_ACT_7_ALL = 0x200000;
var BADGE_ACT_8_ALL = 0x400000;
var BADGE_ACT_9_ALL = 0x800000;

var MAX_BADGE = 0x800000;

var DURATA_BADGE = 4000;

/* dovrebbe essere usato solo per BADGE_SOCIAL e BADGE_REMINDER
 * per BADGE_SKIP5TIPS usa extra5=true nei consigli inviati dalla lista
 * NOTA: accetta anche l'or di più badge, es: BADGE_FAIL | BADGE_THEEND */
function uploadNewBadges(tipo) {
  console.log('upload badges '+tipo);
  $.ajax(baseurl + "actions.php",
  {
      type: 'POST',
      cache: false,
      async: false,
      data: 'action=savebadges&'+getUsernamePassword()+'&badges='+tipo+'&'+getTokenString(),
  })
  .done(function(risp) {
	console.log(risp);
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    permanentStorage.setItem('badges', parseInt(permanentStorage.getItem('badges'))|parseInt(tipo));
  });
}

function badgeSocial() {
	var badges = parseInt(permanentStorage.getItem('badges'));
	if (!(badges & BADGE_SOCIAL)) {
		var tipologie_badges = $.parseJSON(permanentStorage.getItem('tipologie_badges'));
		showSingleBadge(1000, DURATA_BADGE, tipologie_badges[0]['descrizione'],0);
		
		uploadNewBadges(BADGE_SOCIAL);
	}
}

function badgeSkip5() {
	var badges = parseInt(permanentStorage.getItem('badges'));
	console.log("SKIP 5 ??????????????????????????????????????????????"+badges+" "+BADGE_SKIP5TIPS+" "+(badges & BADGE_SKIP5TIPS));
	if (!(badges & BADGE_SKIP5TIPS)) {
		console.log("skip 5!");
		var tipologie_badges = $.parseJSON(permanentStorage.getItem('tipologie_badges'));
		showSingleBadge(2000, DURATA_BADGE, tipologie_badges[1]['descrizione'],1);
	}
}

function badgeReminder() {
	var badges = parseInt(permanentStorage.getItem('badges'));
	if (!(badges & BADGE_REMINDER)) {
		var tipologie_badges = $.parseJSON(permanentStorage.getItem('tipologie_badges'));
		showSingleBadge(1000, DURATA_BADGE, tipologie_badges[10]['descrizione'],10);
		
		uploadNewBadges(BADGE_REMINDER);
	}
}

/** spara la sequenza dei badges */
function showBadges(quali) {
	if (quali == undefined || quali==null || quali=="") return;
	
	console.log("mostro i badges: "+quali);
	var i, j, ctime=0;
	var tipologie_badges = $.parseJSON(permanentStorage.getItem('tipologie_badges'));
	for (j=0, i=1; i<=MAX_BADGE; i*=2, j++) {
		if (quali & i) {
			showSingleBadge(1000 + ctime*(DURATA_BADGE+1000), DURATA_BADGE, tipologie_badges[j]['descrizione'],j);
			ctime++;
		}
	}
	permanentStorage.removeItem('badges_to_show');
}

function showSingleBadge(start, duration,  text, idx) {
	setTimeout(function() {
		$('#badge-content').html( text );
		$('#badge-image-src').attr('src', 'img/page-results-badges/badge-'+strpad(idx+1, 2, '0')+'.png');
		$(document).toggleSticky('#badge', 'bounceInDown');

		setTimeout(function() {
			$(document).toggleSticky('#badge', 'bounceOutLeft');
		}, duration);

	}, start);
	
	$('#badge-item-'+idx).removeClass('active').addClass('active');
}

function stampaBadges() {
	var badges = parseInt($.parseJSON(permanentStorage.getItem('badges')));
	console.log("badges: "+badges);
	
	var i,j;
	for (i=1,j=0; i<=MAX_BADGE; i*=2,j++) {
		if (badges & i) {
			$('#badge-item-'+j).removeClass('active').addClass('active');
		}
		else {
			$('#badge-item-'+j).removeClass('active')
		}
	}
}

/* ------------------------------- Condivisione badge ----------------------------- */
function condividiBadgeFacebook(idx) {
	condividiBadge('fb', idx);
}

function condividiBadgeTwitter(idx) {
	condividiBadge('tw', idx);
}

function condividiBadge(social, idx) {
	
	console.log("condividi badge "+social+" "+idx);
	var tipologie_badges = $.parseJSON(permanentStorage.getItem('tipologie_badges'));
	//creaBase64BadgeAndShare(social, idx, tipologie_badges[idx]);
	
	var link = baseurl+"result.php?a=b&b="+idx+"&c="+permanentStorage.getItem('id');
	
	
	console.log(baseurl+"img/share_immagini/b/"+(parseInt(idx)+1)+".jpg");
	if (social=='tw') {
		window.plugins.socialsharing.shareViaTwitter(tipologie_badges[idx]['dacondividere'].replace(/\[Nome\]/g,permanentStorage.getItem('nome')), baseurl+"img/share_immagini/b/"+(parseInt(idx)+1)+".jpg", null,
			function() {console.log('share ok'); badgeSocial();  condivisioneAvvenutaPopup(); },	// $(document).gotoElement('#layer-badges-start');
			function(errormsg){ condivisioneFallitaPopup(); }
		);
	}
	else {
		window.plugins.socialsharing.shareViaFacebook(null, null, link,
			function() {console.log('share ok'); badgeSocial(); condivisioneAvvenutaPopup(); },		// $(document).gotoElement('#layer-badges-start'); 
			function(errormsg){ condivisioneFallitaPopup(); }
		);
	}
}


/*function creaBase64BadgeAndShare(social, idx, badge) {
	console.log(social+" "+idx+" <"+badge+">");
	
	var canvas = document.createElement("canvas");
	canvas.width = 322;
	canvas.height = 430;
	var ctx = canvas.getContext("2d");
	
	var img = new Image();
    img.onload = function(){
		ctx.fillStyle='#FFFFFF';
		ctx.fillRect(0,0,322,430);
		
		ctx.drawImage(img,(322-207)/2,15);
	
		var fs = 28;
		ctx.font=fs+"px GothamRnd";
		while (ctx.measureText(badge['descrizione']).width > 310) {
			fs--;
			ctx.font=fs+"px GothamRnd";
		}
		ctx.textAlign = 'center';
		ctx.fillStyle='#777777';
		ctx.fillText(badge['descrizione'],161,270); 
		
		ctx.font="14px GothamRnd";
		ctx = stampaTestoMultiline(ctx, badge['testo'], 161, 310, 23, 40); 
		  
		imageData = canvas.toDataURL("image/jpeg");
		
		if (imageData.length>4 && imageData.substring(0,4)!='data')
			imageData = "data:image/jpeg;base64," + imageData;
		
		if (social=='tw') {
			window.plugins.socialsharing.shareViaTwitter(badge['dacondividere'].replace(/\[Nome\]/g,permanentStorage.getItem('nome')), imageData, null,
				function() {console.log('share ok'); $(document).gotoElement('#layer-badges-start');},
				function(errormsg){alert(errormsg); $(document).gotoElement('#layer-badges-start'); }
			);
		}
		else {
			window.plugins.socialsharing.shareViaFacebook(badge['dacondividere'].replace(/\[Nome\]/g,permanentStorage.getItem('nome')), imageData, null,
				function() {console.log('share ok'); $(document).gotoElement('#layer-badges-start');},
				function(errormsg){alert(errormsg); $(document).gotoElement('#layer-badges-start'); }
			);
		}
	}
	// qui carica il badge con l'id corretto!
	idx = 'x';
	img.src = 'img/page-results-badges/badge-'+idx+'.png';
}*/

/* ------------------------------- Condivisione risultati ----------------------------- */
function condividiRisultatiFacebook() {
	condividiRisultati('fb');
}

function condividiRisultatiTwitter() {
	condividiRisultati('tw');
}

function condividiRisultati(social) {
	console.log("condividi risultati "+social);
	
	/*var tipologie_percorso = reorganizeArray( $.parseJSON( permanentStorage.getItem('tipologie_percorso') ));
	var storico = $.parseJSON( permanentStorage.getItem('storico') );
	corrente = storico.corrente;
	if (!(corrente==null || corrente==undefined)) {
		
		var v1 = 0;
		var v2 = 0;
		var v3 = 0;
		for (idx=0; idx<corrente.dettaglio_consigli.length; idx++) {
		  v = corrente.dettaglio_consigli[idx];
		  if (parseInt(v['tipologia_consiglio']) == 4)	// attivita
			v2 = parseInt(v['tot']);
		  else if (parseInt(v['tipologia_consiglio']) == 5)	// food and drink
			v1 = parseInt(v['tot']);
		  else if (parseInt(v['tipologia_consiglio']) == 6)	// buone abitudini
			v3 = parseInt(v['tot']);
		}
		var v4 = parseInt(corrente['consigli_falliti']);
		
		//creaBase64RisultatiAndShare(social, tipologie_percorso[parseInt(corrente['tipologia_percorso'])].descrizione, days_from_start(corrente['data_inizio']), v1, v2, v3, v4);
	}*/
	
	var link = baseurl+"result.php?a=r&b="+risultato_da_condividere;
	tipo = Math.floor((punteggio*100.0/30)/20);
	
	console.log(punteggio+" "+tipo);
	
	console.log(baseurl+"img/share_immagini/r/r.jpg");
	console.log(link);
	
	var testi = new Array();

	testi[0] = 'Diciamo che ti sei distratto un pochino? :D Dai su, con un po\' più di buona volontà scoprirai quant\'è facile e semplice star bene.';
	testi[1] = 'Ok dai, ci hai provato! Certo che qualche consiglio in più, poca attenzione, e magari le sveglie ti avrebbero aiutato. Alla fine sai cosa si dice in queste situazioni no? L\'importante è partecipare!';
	testi[2] = 'Hai sentito gli effetti del programma, vero? Ma chi ha detto che ti devi fermare qui? Continua a usare Semplice Star Bene, poniti un nuovo obiettivo, e tenta di fare sempre meglio! Da qui in poi non si può far altro che migliorare. ';
	testi[3] = 'Sei arrivato fin qua e i risultati si vedono! Ti senti meglio vero? E il tutto senza neanche un piccolo grande sacrificio. È bastato un buon consiglio al giorno tutti i giorni. Non fermarti qui, si può sempre migliorare! Continua e scegli un nuovo obiettivo per il tuo Semplice Star Bene.';
	testi[4] = 'Hai colto in pieno lo spirito del Semplice Star Bene! Ammettilo, stai meglio vero? Visto come un buon consiglio al giorno, tutti i giorni, ti porta lontano senza troppa fatica? Complimenti, davvero! Un consiglio? Adesso scegli un nuovo obiettivo!';
	
	if (social=='tw') {
		window.plugins.socialsharing.shareViaTwitter(testi[tipo], baseurl+"img/share_immagini/r/r.jpg", null,
			function() {console.log('share ok'); badgeSocial(); condivisioneAvvenutaPopup(); },	// $(document).gotoElement('#layer-badges-start');
			function(errormsg){ condivisioneFallitaPopup();	}
		);
	}
	else {
		window.plugins.socialsharing.shareViaFacebook(null, null, link,
			function() { console.log('share ok'); badgeSocial(); condivisioneAvvenutaPopup(); },		// $(document).gotoElement('#layer-results-start');
			function(errormsg){ condivisioneFallitaPopup(); }
		);
	}
}

/*
function creaBase64RisultatiAndShare(social, obiettivo, giorni, v1, v2, v3, v4) {
	console.log("condividi risultati "+social+" "+obiettivo+" "+giorni);
	
	var canvas = document.createElement("canvas");
	canvas.width = 322;
	canvas.height = 430;
	var ctx = canvas.getContext("2d");
	
	var img = new Image();
    img.onload = function(){
		var risCanvas = $('#layer-results-result-share canvas')[0];
		
		ctx.fillStyle='#FFFFFF';
		ctx.fillRect(0,0,322,430);
		var w=180, h=180;
		var x=(322-w)/2,y=30;
		ctx.drawImage(risCanvas,0,0,risCanvas.width, risCanvas.height,x,y,w,h);
	
		ctx.font = "32px GothamRnd";
		ctx.textAlign = 'center';
		ctx.fillStyle='#555555';
		ctx.fillText(formatNumber(v1+v2+v3+v4, 30)+"%",161,135); 
	
		ctx.font = "28px GothamRnd";
		ctx.textAlign = 'center';
		ctx.fillStyle='#777777';
		ctx.fillText("RISULTATI",161,270); 
		
		ctx.font="18px GothamRnd";
		ctx.fillText("Obiettivo: "+obiettivo,161,310); 
		
		ctx.fillStyle='#999999';
		ctx.font="15px GothamRnd";
		ctx.fillText("Consigli svolti: "+(v1+v2+v3),161,340); 

		imageData = canvas.toDataURL("image/jpeg");
		
		if (imageData.length>4 && imageData.substring(0,4)!='data')
			imageData = "data:image/jpeg;base64," + imageData;
		
		if (social=='tw') {
			window.plugins.socialsharing.shareViaTwitter(null, imageData, null,
				function() {console.log('share ok'); $(document).gotoElement('#layer-results-start');},
				function(errormsg){alert(errormsg); $(document).gotoElement('#layer-results-start'); }
			);
		}
		else {
			window.plugins.socialsharing.shareViaFacebook(null, imageData, null,
				function() {console.log('share ok'); $(document).gotoElement('#layer-results-start');},
				function(errormsg){alert(errormsg); $(document).gotoElement('#layer-results-start'); }
			);
		}
	}
	// qui carica il badge con l'id corretto!
	idx = 'x';
	img.src = 'img/page-results-badges/badge-'+idx+'.png';
}
*/

function condivisioneAvvenutaPopup() {
	// Sticky
	$(document).toggleSticky('#share-tick');

	setTimeout(function() {
		// De-Sticky
		$(document).toggleSticky('#share-tick');
	}, 2000);
}

function condivisioneFallitaPopup() {
	// Sticky
	$(document).toggleSticky('#share-tick-err');

	setTimeout(function() {
		// De-Sticky
		$(document).toggleSticky('#share-tick-err');
	}, 2000);
}
