var baseurl            = "http://sognidoro.inet2.it/";
var consiglio          = null;
var permanentStorage   = window.localStorage;
var is_tip_selected = false;
var is_activity_selected = false;

var is_valutazione_consiglio = false;

console.log = function() {};

function getData(diffGiorni) {
	var adesso = new Date();
	
	var data = new Date(adesso.getTime() + diffGiorni*24*3600*1000);
	
	console.log('getData: '+data.getFullYear()+"-"+(data.getMonth()+1)+"-"+data.getDate());
	
	return data.getFullYear()+"-"+(data.getMonth()+1)+"-"+data.getDate();
}

function getDataOra(diffGiorni) {
	var adesso = new Date();
	
	var data = new Date(adesso.getTime() + diffGiorni*24*3600*1000);
	
	console.log('getDataOra: '+data.getFullYear()+"-"+(data.getMonth()+1)+"-"+data.getDate()+" "+data.getHours()+":"+data.getMinutes()+":"+data.getSeconds());
	
	return data.getFullYear()+"-"+(data.getMonth()+1)+"-"+data.getDate()+" "+data.getHours()+":"+data.getMinutes()+":"+data.getSeconds();
}

/* se è oggi deve ritornare uno */
function days_from_start(data_inizio) {
	var adesso = new Date();
	adesso.setHours(2);
	adesso.setMinutes(0);
	adesso.setSeconds(0);
	
	var pezzi = data_inizio.split(' ');
	var data = pezzi[0].split('-');
	
	var inizio = new Date(data[0], data[1]-1, data[2]);
	inizio.setHours(1);
	inizio.setMinutes(0);
	inizio.setSeconds(0);
	
	var msec_per_giorno = 24*3600*1000;
	
	console.log(inizio);
	console.log(adesso);
	
	return Math.ceil((adesso.getTime() - inizio.getTime()) / msec_per_giorno);
}

function date_sub(date1, date2) {
	console.log('date_sub: '+date1+" "+date2);
	date1 = date1.split(' ');
	date1 = date1[0].split('-');
	date1 = new Date(date1[0], date1[1], date1[2]);

	date2 = date2.split(' ');
	date2 = date2[0].split('-');
	date2 = new Date(date2[0], date2[1], date2[2]);
	
	console.log(date1-date2);
	return date1-date2;
}

function days_diff(data_inizio, data_fine) {
	console.log('days_diff: '+data_inizio+" "+data_fine);
	data_inizio = data_inizio.split(' ');
	data_inizio = data_inizio[0].split('-');
	var inizio = new Date(data_inizio[0], data_inizio[1], data_inizio[2]);

	data_fine = data_fine.split(' ');
	data_fine = data_fine[0].split('-');
	var fine = new Date(data_fine[0], data_fine[1], data_fine[2]);
	
	var msec_per_giorno = 24*3600*1000;
	
	return Math.min(((fine.getTime()-inizio.getTime())/msec_per_giorno)+1, 30);
}

function getUsernamePassword() {
	return "username="+encodeURIComponent(permanentStorage.getItem("username"))+"&password="+encodeURIComponent(permanentStorage.getItem("password"));
}

function accettaConsiglio(id_consiglio, is_skip_5) {
  console.log('action=changedettaglio&'+getUsernamePassword()+'&iddettaglio='+id_consiglio+(is_skip_5 ? '&extra5=true' : '') );

  start_wait();

  setTimeout( function() {
	  $.ajax( baseurl + "actions.php", {
		  type: 'POST',
		  cache: false,
		  async: false,
		  data: 'action=changedettaglio&'+getUsernamePassword()+'&iddettaglio='+id_consiglio+'&tipologia_dettaglio=consiglio&stato=accettato'+(is_skip_5 ? '&extra5=true' : '')+'&'+getTokenString(),
	  })
	  .done(function(risp) {
		risp = $.parseJSON(risp);
		error = risp.error;
		successo = risp.success;
		data = risp.data;

		if(successo == true) {
		  getDatiUtenteOggi();
		  refreshValoriInGrafica();
		  var now = new Date();
		  if(now.getHours() < 20) {
			  now.setHours(20);
			  now.setMinutes(00);
			  now.setSeconds(00);
			  creaNotifica(id_consiglio+'_ricorda_consiglio', 'Semplice star bene', 'Hai seguito il consiglio di oggi? Raccontaci come è andata!', now ,
											JSON.stringify({ 'tipo':'ricorda_consiglio'}));
			  permanentStorage.setItem('ricorda_consiglio_id', id_consiglio+'_ricorda_consiglio');
		  }
		  
		  setTempoReminder();
		  $(document).gotoElement('#layout-home');
		  $(document).gotoElement('#layer-home-tip-reminder', '', '', true);
		  
		  end_wait();
		  // toglie eventuali layer sopra..
		  $('.layer.active').removeClass('active');
		  $('#layer-home-start').removeClass('active').addClass('active');
		}
		else {
		  getDatiUtenteOggi();
		  refreshValoriInGrafica();
		  console.log(error);
		  end_wait();
		}
	  });
  }, 100);
}

function accettaAttivita() {
  start_wait();
	
  setTimeout( function() {
	  $.ajax( baseurl + "actions.php", {
		  type: 'POST',
		  cache: false,
		  async: false,
		  data: 'action=changedettaglio&'+getUsernamePassword()+'&iddettaglio='+
					$('#attivita_selezionata_text').attr('idattivita')+'&tipologia_dettaglio=attivita&stato=accettato'+'&'+getTokenString(),
	  })
	  .done(function(risp) {
		risp = $.parseJSON(risp);
		error = risp.error;
		successo = risp.success;
		data = risp.data;

		// TODO: usa i layer della grafica
		//if(successo == true) {
		  getDatiUtenteOggi();
		  refreshValoriInGrafica();
		  $(document).gotoElement('#layer-home-start');
		  end_wait();
		/*}
		else {
		  console.log(error);
		  end_wait();
	    }*/
	  });
  }, 100);
}

function registrazioneForm() {
	console.log("registrazioneForm");
	$.ajax( baseurl+"registrati.php"+"?"+getTokenString(), {
	  type: 'GET',
		cache: false,
		async: false,
	}).done(function(risp) {
		risp = $.parseJSON(risp);
		$("#divFormRegistrazione").html(risp.form);
	//	console.log("divFormRegistrazione: " + $("#divFormRegistrazione").html());
		$(document).gotoElement('#layer-login-register', 'fadeOut', 'fadeIn', false);
		aggiornaLinkLista();
	});
}

function recuperaPasswordForm() {
  $.ajax( baseurl+"recuperapassword.php"+"?"+getTokenString(), {
    type: 'GET',
    cache: false,
    async: false,
  }).done(function(risp) {
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    data = risp.form;
    $("#divFormRecuperaPassword").html(data);
    
    $(document).gotoElement('#layer-login-password');
    aggiornaLinkLista();
  });
}

function recuperapassword() {
  $.ajax( baseurl+"recuperapassword.php", {
    type: 'POST',
    data: $('#formRecupera').serialize()+"&"+getTokenString(),
    cache: false,
    async: false,
  }).done(function(risp) {
	//  console.log(risp);
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    data = risp.form;
    if(!successo && error != 'NON POST') {
      $('#error-login-password').html(error);
      $(document).gotoElement('#layer-login-password .panel-error');
      $("#divFormRecuperaPassword").html(data);
    }
    else {
      $('#error-login-password').html("La nuova password è stata inviata all'indirizzo email indicato");
      $(document).gotoElement('#layer-login-password .panel-error');
    }

    aggiornaLinkLista();
  });
}


function strpad(str, length, c) {
    var ris = ""+str;
    while (ris.length < length)
        ris = c + ris;
    return ris;
}

function getDataPerNotifica(data, ora) {
	var adesso = new Date();
    
    var oggi = adesso.getFullYear()+"-"+strpad(1+adesso.getMonth(), 2, "0")+"-"+strpad(adesso.getDate(), 2, "0");
    
    var output = ""+data+" "+ora+" "+oggi;
    
    if (data == oggi) {
		data = data.split('-');
		var data_notifica = new Date(data[0], data[1]-1, data[2]);
		ora = ora.split(':');
		data_notifica.setHours(ora[0]);
		data_notifica.setMinutes(ora[1]);
		data_notifica.setSeconds(ora[2]);
		
		if (data_notifica.getTime() < adesso.getTime()) {
			data_notifica = adesso;
			data_notifica.setMinutes(adesso.getMinutes()+1);
		}
	}
	else {
		data = data.split('-');
		var data_notifica = new Date(data[0], data[1]-1, data[2]);
		ora = ora.split(':');
		data_notifica.setHours(ora[0]);
		data_notifica.setMinutes(ora[1]);
		data_notifica.setSeconds(ora[2]);
	}
    
    console.log(output+" "+data_notifica);
    
    return data_notifica;
}

function creaNotifica(id, title, message, data, json){
	console.log('crea notifica: '+id+" <"+title+"> <"+message+"> "+data);

	window.plugin.notification.local.add({
		id:      id,
		title:   title,
		message: message,
		date:    data,
		json: 	 json
	});   
}

function schedulazioneNotificheConsigli() {
	console.log('schedulazioneNotificheConsigli');
	var notifiche_consigli =  $.parseJSON(permanentStorage.getItem('consigli_da_schedulare'));
	if (notifiche_consigli != 'null' && notifiche_consigli.length > 0) {
		var ora = new Date();
		var oggi = ora.getFullYear()+"-"+strpad((ora.getMonth()+1),2,'0')+"-"+strpad(ora.getDate(),2,'0');
		$.each(notifiche_consigli, function(idx, v) {
			console.log(""+idx+": "+v['data']);
			//alert(""+idx+": "+v['data']+" "+oggi+" "+data)
			var dataora = oggi+ora.getHours()+":"+ora.getMinutes()+":"+ora.getSeconds();
			if (v['data']>oggi || v['data']+v['ora'] >dataora) { 
				creaNotifica(v['id'], 'Semplice Star Bene', permanentStorage.getItem('nome')+'! Oggi ricordati di scegliere un semplice consiglio!',
							getDataPerNotifica(v['data'], v['ora']), JSON.stringify({ 'consiglio': '' }));
			}
		/*	// pezzo di test, per schedulare quella di oggi fra un minuto
			else {
				creaNotifica(v['id'], 'Semplice Star Bene', permanentStorage.getItem('nome')+'! Oggi ricordati di scegliere un semplice consiglio!',
							getDataPerNotifica(v['data'], ora.getHours()+":"+(ora.getMinutes()+1)+":00"), JSON.stringify({ 'consiglio': '' }));
			}*/
		});
		console.log("fine notifiche");
	}
	
	end_wait();
}

function aggiornaLinkLista() {
  $('.click-to-element').off('click');
  $('.swipe-to-element').off('click');
  $('.input-target-options a').off('click');
  $('.group-content').off('click');
  $('#badges-items a').off('click');

  bindClickToElement();
  bindInputTargetOptions();
  bindGroupContent();
  bindSwipeToElement();
  
  $('#badges-items a').on('click', function () {
	var idx = $(this).attr('id').split('-');
	idx = idx[2];
	console.log(idx);
	var tipologie_badges = $.parseJSON(permanentStorage.getItem('tipologie_badges'));
	
	$("#layer-badges-badge-selected-title").html(tipologie_badges[idx]['descrizione']);
	$("#layer-badges-badge-share-title").html(tipologie_badges[idx]['descrizione']);
	$('#layer-badges-badge-selected-image').attr('src', "img/page-results-badges/badge-"+strpad(parseInt(idx)+1, 2, '0')+".png");
	$('#layer-badges-badge-share-image').attr('src', "img/page-results-badges/badge-"+strpad(parseInt(idx)+1, 2, '0')+".png");
	if ($('#badge-item-'+idx).hasClass('active')) {
		$("#layer-badges-badge-selected-content").html(tipologie_badges[idx]['testo']);
		$('#layer-badges-badge-selected .notification').removeClass('active').addClass('active');
		
		$("#layer-badges-badge-share-content").html(tipologie_badges[idx]['dacondividere'].replace(/\[Nome\]/g,permanentStorage.getItem("nome")));
		$('#layer-badges-badge-share .notification').removeClass('active').addClass('active');
		$('#layer-badges-badge-share-fb').off('click');
		$('#layer-badges-badge-share-fb').on('click', function () {
			condividiBadgeFacebook(idx);
		});
		$('#layer-badges-badge-share-tw').off('click');
		$('#layer-badges-badge-share-tw').on('click', function () {
			condividiBadgeTwitter(idx);
		});
	}
	else {
		$("#layer-badges-badge-selected-content").html($('#badge-item-'+idx+' .todo').html());
		$('#layer-badges-badge-selected .notification').removeClass('active');
	}
  });
}

function gotoNuovoPercorso() {
	$('#id_obiettivo').val("");
	$('#id_rinuncia').val("");
	
	listaPercorsi();
	$('.layout.active').removeClass('active');
	$('.page.active').removeClass('active');
	$('.layer.active').removeClass('active');
	$('.layer.overlay').removeClass('overlay');

	$('#layout-login').addClass('active');
	$('#page-login').addClass('active');
	$('#layer-login-target-goal').addClass('active');
}

function listaPercorsi() {
  console.log('listaPercorsi');
  var percorsi = $.parseJSON(permanentStorage.getItem('tipologie_percorso'));
  var righe = '';
  var flag_first = true;

  $.each(percorsi, function(k, v) {
    righe += '<a class="list-group-item" href="index.html#" data-input-value="'+v['id']+'" onclick="$(\'#id_obiettivo\').val('+v['id']+');">'+v['descrizione']+' <span class="icomoon pull-right"></span></a>';
  });

  $('#percorsi').html(righe);
  aggiornaLinkLista();
  
  $(document).gotoElement('#layer-login-target-goal');
}

// testo il primo accesso del giorno
function isPrimoAccesso() {
  // isPrimoAccesso viene chiamato ogni cambio giorno, in data_primo_accesso c'è la data dell'ultima visualizzazione automatica di un consiglio
  var data_primo_accesso = permanentStorage.getItem('data_primo_accesso_del_giorno');
  is_null = false;
  if (!data_primo_accesso || data_primo_accesso === undefined) {
    data_primo_accesso = getDataOra(0);
    is_null = true;
  }

  // se è passato almeno un gg
  if (is_null || date_sub(getDataOra(0), data_primo_accesso) > 0) {
	  console.log("IS PRIMO ACCESSO: true");
      permanentStorage.setItem('data_primo_accesso_del_giorno', getDataOra(0));
    
      if(!is_tip_selected) {
        console.log('go consigli');
    	setTimeout( function() { onClickGotoConsigli(); }, 200 );
    	console.log('5 consigli');
      }
  }
  else
	console.log("IS PRIMO ACCESSO: false");
}

function salvaPercorsoRinuncia(id_rinuncia) {
  if(id_rinuncia && id_rinuncia != "") {
	start_wait();
	setTimeout(function() {
		permanentStorage.setItem("id_rinuncia", id_rinuncia);
		$.ajax( baseurl+"actions.php", {
		  type: 'POST',
		  data: 'action=saveprofilazione&'+getUsernamePassword()+'&idpercorso='+permanentStorage.getItem('id_obiettivo')+'&idrinuncia='+permanentStorage.getItem('id_rinuncia')+'&'+getTokenString(),
		  cache: false,
		  async: false,
		}).done(function(risp) {
		//	console.log(risp);
		  risp = $.parseJSON(risp);
		  data = risp.data;
		  if(risp.success) {
			permanentStorage.setItem("id_percorso", data['id_percorso']);
			permanentStorage.setItem('tipologia_percorso', data['tipologia_percorso']);
			permanentStorage.setItem('consigli_da_schedulare', JSON.stringify(risp.data['consigli_da_schedulare']));
			schedulazioneNotificheConsigli();

			getDatiUtenteOggi();
			refreshValoriInGrafica();
			$(document).gotoElement("#layout-home");
			$(document).gotoElement("#layer-home-tip", '', '', true);
			
		  }
		  else {
			  end_wait();
		  }
		  
		});
	}, 100);
  }
  else {
    $(document).gotoElement('#layer-login-target-waiver-panel-error', '', '', true);
    end_wait();
  }
}

function listaRinunce(id_obiettivo) {
  console.log(id_obiettivo);
  if (id_obiettivo && id_obiettivo != "") {
	console.log(id_obiettivo);
    permanentStorage.setItem('id_obiettivo', id_obiettivo);
    //var percorsi = $.parseJSON(permanentStorage.getItem('tipologie_percorso'));
    var rinunce  = $.parseJSON(permanentStorage.getItem('tipologie_rinuncia'));
    var righe = '';
    var flag_first = true;

    if(rinunce) {
      $.each(rinunce, function(k, v) {
        righe += '<a class="list-group-item" href="index.html#" data-input-value="'+v['id']+'" onclick="$(\'#id_rinuncia\').val('+v['id']+');">'+v['descrizione']+' <span class="icomoon pull-right"></span></a>';
        if(flag_first) {
          flag_first = false;
        }
      });
    }
    $('#rinunce').html(righe);
    aggiornaLinkLista();
    
    $(document).gotoElement('#layer-login-target-waiver');
  }
  else
    $(document).gotoElement('#layer-login-target-goal-panel-error', '', '', true);
}

/* ritorna true se devo scaricarla, false se è già aggiornata */
function verificaFotoProfilo(image_date) {
	if (image_date!= undefined && image_date!= null && image_date!='' && image_date != 'null') {
		var vecchia_data = permanentStorage.getItem('image_date');
		if (permanentStorage.getItem('profileImage'+permanentStorage.getItem("id")) == 'false' ||
			(vecchia_data!= undefined && vecchia_data!= null && vecchia_data!='' && vecchia_data != 'null' && date_sub(image_date, vecchia_data)>0) )
		{ // non è stata ancora caricata o è vecchia
			permanentStorage.setItem('image_date', image_date);
			return true;
		}
	}
	return false;
}

function registrati() {
  start_wait();
  setTimeout(function() {
	  $.ajax(baseurl + "registrati.php",
	  {
		type: 'POST',
		cache: false,
		async: false,
		data: $('#formRegistrazione').serialize()+"&"+getTokenString()
	  })
	  .done(function(risp) {
		risp     = $.parseJSON(risp);
		error    = risp.error;
		successo = risp.success;
		data     = risp.form;
		if(successo == true) {
		  impostaValoriLocalStorage(data)
		  permanentStorage.setItem("password", $("#formRegistrazione #password").val());
		  permanentStorage.setItem('profileImage'+permanentStorage.getItem("id"), 'false');
		  end_wait();
		  $(document).gotoElement('#layer-login-photo-upload');
		}
		else {
		  end_wait();console.log("============================================ ON PAUSE");
    window.localStorage.setItem('data_ultimo_aggiornamento', getDataOra(-1));
	window.loca
		  $('#messaggio_errore_registrazione').html(error);
		  $(document).gotoElement('#layer-login-register .panel-error');
		  form = risp.form;
		}
	  });
	}, 100);
}

function loadRegistrazioneForm() {
  registrazioneForm();
}

function impostaValoriLocalStorage(data) {
  console.log('id: '+data['id']);
  permanentStorage.setItem('id', data['id']);
  console.log('nome: '+data['nome']);
  permanentStorage.setItem('nome', data['nome']);
  console.log('cognome: '+data['cognome']);
  permanentStorage.setItem('cognome', data['cognome']);
  console.log('username: '+data['username']);
  permanentStorage.setItem('username', data['username']);
  permanentStorage.setItem('data_ultimo_aggiornamento', getDataOra(0));
  permanentStorage.setItem('id_percorso', data['id_percorso']);
  permanentStorage.setItem('tipologia_percorso', data['tipologia_percorso']);
  permanentStorage.setItem('tipologie_percorso', JSON.stringify(data['tipologie_percorso']));
  permanentStorage.setItem('tipologie_consiglio', JSON.stringify(data['tipologie_consiglio']));
  permanentStorage.setItem('tipologie_rinuncia', JSON.stringify(data['tipologie_rinuncia']));
  permanentStorage.setItem('tipologie_attivita', JSON.stringify(reorganizeArray(data['tipologie_attivita'])));
  console.log(data['tipologie_badges']);
  permanentStorage.setItem('tipologie_badges', JSON.stringify(data['tipologie_badges']));
  
  permanentStorage.setItem('image_date', data['image_date']);
  
  permanentStorage.setItem('data_ultimo_login', data.data_ultimo_login);
}

function reorganizeArray(oldArray) {
  var ris = new Array();
  for (i=0; i<oldArray.length; i++) {
	  ris[oldArray[i].id] = { 'descrizione': oldArray[i].descrizione };
  }
  
  return ris;
}

function getFormCambiapassword() {
	console.log("cambiapassword");
	$.ajax( baseurl+"cambiapassword.php"+"?"+getTokenString(), {
	  type: 'GET',
		cache: false,
		async: false,
	}).done(function(risp) {
		risp = $.parseJSON(risp);
		$("#divFormRecuperaPassword").html(risp.form);
		
	//	console.log("divFormRegistrazione: " + $("#divFormRegistrazione").html());
		$(document).gotoElement('#layer-login-password', 'fadeOut', 'fadeIn', false);
		
		console.log('imposto nome utente '+permanentStorage.getItem('username'));
		$("#divFormRecuperaPassword #username").val(permanentStorage.getItem('username'));
		aggiornaLinkLista();
	});
}

function cambiapassword() {
  console.log('cambiapassword');
  $.ajax( baseurl + "cambiapassword.php",
  {
      type: 'POST',
      cache: false,
      async: false,
      data: $('#formCambiapassword').serialize()+"&"+getTokenString()
  })
  .done(function(risp) {
	  console.log(risp);
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    
    if(successo == true) {
	  permanentStorage.setItem('password', $('#formCambiapassword #password').val());
	  
      if (data['id_percorso'] != null) {
        schedulazioneNotificheConsigli();

        getDatiUtenteOggi();
        refreshValoriInGrafica();
        $(document).gotoElement('#layout-home');
      }
      else {
		listaPercorsi();
        $(document).gotoElement('#layer-login-target-goal');
      }
    }
    else {
      $('#error-login-password').html(error);
      $(document).gotoElement('#layer-login-password .panel-error');
    }
  });

}


function login(password) {
  console.log('login');
  start_wait();
  setTimeout( function() {
	  $.ajax( baseurl + "actions.php",
	  {
		  type: 'POST',
		  cache: false,
		  async: false,
		  data: $('#form_login').serialize()+"&"+getTokenString()
	  })
	  .done(function(risp) {
		risp = $.parseJSON(risp);
		error = risp.error;
		successo = risp.success;
		data = risp.data;
		
		if(successo == true) {
		  impostaValoriLocalStorage(data);
		  
		  permanentStorage.setItem('profileImage'+permanentStorage.getItem("id"), 'false');
		  
		  if (data['cambia_password']===true) {
			  // intanto li salvo, li schedulo in cambia password
			permanentStorage.setItem('consigli_da_schedulare', JSON.stringify(data['consigli_da_schedulare']));
			getFormCambiapassword();
			end_wait();
			return;
		  }
		  
		  permanentStorage.setItem('password', password);
		  
		  if (data['id_percorso'] != null) {
			permanentStorage.setItem('consigli_da_schedulare', JSON.stringify(data['consigli_da_schedulare']));
			schedulazioneNotificheConsigli();

			getDatiUtenteOggi();
			refreshValoriInGrafica();
			$(document).gotoElement("#layout-home");
			isPrimoAccesso();
			end_wait();
		  }
		  else {
			listaPercorsi();
			$(document).gotoElement('#layer-login-target-goal');
			end_wait();
		  }
		}
		else {
		  end_wait();
		  $('#messaggio_errore_login').html(error);
		  $(document).gotoElement('#layer-login-login .panel-error');
		}
	  });
	}, 100);
}

function getAttivita() {
  console.log('get attivita');
  $.ajax( baseurl + "actions.php",
  {
      type: 'POST',
      cache: false,
      async: false,
      data: 'action=getlistaattivita&'+getUsernamePassword()+'&'+getTokenString(),
  })
  .done(function(risp) {
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    data = risp.data;
    console.log(data);
    permanentStorage.setItem('attivita_lista', JSON.stringify(data));
  });
}

function getConsigli() {
  console.log('get consigli');
  $.ajax( baseurl + "actions.php",
  {
      type: 'POST',
      cache: false,
      async: false,
      data: 'action=getlistaconsigli&'+getUsernamePassword()+'&'+getTokenString(),
  })
  .done(function(risp) {
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    data = risp.data;
    console.log(data);
    permanentStorage.setItem('consigli_lista', JSON.stringify(data));
  });
}

function onClickActivityList(k, k1, id) {
	if (!isPercorsoDefinito()) {
		gotoKeepCalm('noperc');
		return;
	}
	
	console.log("onclick lista attivita: "+(is_activity_selected ? "" : "non ")+"c'è già un'attività "+k+" "+k1+" "+id);
	if (!is_activity_selected) {
		gotoDettaglioAttivita(k, k1, id);
	} else {
		gotoKeepCalm('task');
	}
}

function isPercorsoDefinito() {
	var idperc = permanentStorage.getItem('id_percorso');
	
	return !(idperc == undefined || idperc == null || idperc == 'undefined' || idperc == 'null');
}

function onClickGotoConsigli() {
	console.log("onclick 5 consigli: "+(is_tip_selected ? "" : "non ")+"c'è già un consiglio");
	
	if (!isPercorsoDefinito()) {
		gotoKeepCalm('noperc');
		return;
	}
	
	if (!is_tip_selected) {
		$(document).gotoElement('#layer-home-tip','','', true);
	} else {
		gotoKeepCalm('tip');
	}
}

// tip, task, noperc
function gotoKeepCalm(tipo) {
	$('#layer-home-keep-calm-msg-tip').hide();
	$('#layer-home-keep-calm-msg-task').hide();
	$('#layer-home-keep-calm-msg-noperc').hide();
	
	$('#layer-home-keep-calm-msg-'+tipo).show();
	
	$(document).gotoElement('#layer-home-start');
	$(document).gotoElement('#layer-home-keep-calm', '', '', true);
}

function stampaAttivita(aggiornaLink) {
  console.log('stampa attivita');
  
  $('#task-today').removeClass('swipe-left');
  
  var att_str         = '';
  var categoria_count = 1;
  attivita_lista  = $.parseJSON(permanentStorage.getItem('attivita_lista'));
  tipologie_attivita = $.parseJSON(permanentStorage.getItem('tipologie_attivita'));
							
  $.each(attivita_lista, function(k, v) {
    att_str += '<div id="task-category-'+categoria_count+'" class="list-group task-category"><a href="index.html#task-category-'+categoria_count+
			'-items" class="group-content" data-toggle="collapse" data-parent="#task-items" aria-expanded="false" aria-controls="task-category-'+categoria_count+
			'-items"> <div class="group-arrow h2 pull-right"> <span class="icomoon icomoon-down"></span></div><h3>'+tipologie_attivita[k].descrizione+
			'</h3></a><div id="task-category-'+categoria_count+'-items" class="list-group-items collapse" aria-labelledby="task-category'+categoria_count+'">';
    var att_count = 1;

    $.each(v, function(k1, v1) {
	  var checkMark = '';
	  var myonclick = '';
	  if (v1['stato'] == '5' || v1['stato'] == '6') {
		checkMark = ' <span class="checkmark '+(v1['stato'] == '5' ? 'active icomoon icomoon-oklight' : '  icomoon icomoon-kolight')+'"></span>';
	  }
	  else {
		//myonclick = 'onclick="if (!is_activity_selected) { gotoDettaglioAttivita('+k+', '+k1+',' + v1['id'] +'); } else { $(\'#layer-home-keep-calm-msg-activity\').show(); $(\'#layer-home-keep-calm-msg-tip\').hide(); $(document).gotoElement(\'#layer-home-keep-calm\'); }"';
		myonclick = 'onclick="onClickActivityList('+k+', '+k1+',' + v1['id'] +');"';
	  }
       att_str += '<div id="list-item-'+att_count+'" class="list-item task task-category-'+att_count+
				'"><a href="index.html#" class="item-content" '+myonclick+'><div class="item-arrow h2 pull-right">'+
				'<span class="icomoon icomoon-right"></span></div><h4>'+tipologie_attivita[k].descrizione+' '+
				att_count+checkMark+'</h4><div class="ellipsis"><p>'+v1['attivita']+'</p></div></a></div>';
      att_count++;
    });

    att_str += '</div></div>';
    categoria_count++;
  });
  $('#task-items').html(att_str);
  
  if (aggiornaLink)
	aggiornaLinkLista();

}

function gotoDettaglioAttivita(idx_categoria_attivita, idx_attivita, idattivita) {
  attivita_lista  = $.parseJSON(permanentStorage.getItem('attivita_lista'));
 
  tipologie_attivita  = $.parseJSON(permanentStorage.getItem('tipologie_attivita'));
  $('#attivita_selezionata_title').html(tipologie_attivita[attivita_lista[idx_categoria_attivita][idx_attivita]['tipologia']]['descrizione'].toUpperCase());
  $('#attivita_selezionata_text').html(attivita_lista[idx_categoria_attivita][idx_attivita]['attivita']);
  $('#attivita_selezionata_text').attr('idattivita', idattivita);
  
  $(document).gotoElement('#layer-home-task', '', '', true);
}

function getDatiUtenteOggi() {
  console.log('getDatiUtenteOggi action=index');

  var dati = 'action=index&'+getUsernamePassword()+'&'+getTokenString();

  $.ajax( baseurl + "actions.php",
  {
      type: 'POST',
      cache: false,
      async: false,
      data: dati,
  })
  .done(function(risp) {
    risp = $.parseJSON(risp);
    error = risp.error;
    successo = risp.success;
    data = risp.data;

    if(successo == true) {
      permanentStorage.setItem('cinque_consigli', JSON.stringify(data['cinque_consigli']));
      permanentStorage.setItem('storico', JSON.stringify(data['storico']));
      permanentStorage.setItem('dettaglio_oggi', JSON.stringify(data['dettaglio_oggi']));
      permanentStorage.setItem('attivita_lista', JSON.stringify(data['lista_attivita']));
      permanentStorage.setItem('consigli_lista', JSON.stringify(data['lista_consigli']));
      permanentStorage.setItem('badges', data['badges']);
      permanentStorage.setItem('badges_to_show', data['badges_to_show']);
      
      permanentStorage.setItem('id_percorso', data['id_percorso']);
      permanentStorage.setItem('image_date', data['image_date']);
      
      console.log("badges: "+data['badges'].toString(16)+" "+data['badges_to_show'].toString(16));
     
      // scarico immagine se non ho l'immagine ma image_data != null o se image_data < dell'image_data che ho in permanentStorage
      if (verificaFotoProfilo(data['image_date'])) {
		  console.log("immagine da caricare o sostituire");
		  scaricaImmagineUtente();
	  }
	  else {
		  console.log("va bene l'immagine in memoria");
	  }
    }

	// ora questi sono fatti direttamente da index
  //  getAttivita();
  //  getConsigli();
  });
}

function refreshValoriInGrafica() {
	showContinuaToPercorso(false);
	
	console.log('refreshValoriInGrafica');
	
	if (!permanentStorage.getItem("id_percorso")) {
		showContinuaToPercorso(true);
	}
	
	stampaConsigli(false);
	stampaAttivita(false);
	stampaInfoOggi(false);
	stampaStorico();
	stampaBadges();
	showBadges(permanentStorage.getItem('badges_to_show'));
	aggiornaLinkLista();
	
	$('#user-name').html(permanentStorage.getItem("nome"));
	storico = $.parseJSON(permanentStorage.getItem('storico'));
	storico = storico['corrente'];
	if (storico) {
		$('#user-days-nr').html(strpad(days_from_start(storico['data_inizio']),2,'0'));
		console.log(strpad(storico['tot_consigli'],2,'0'));
		$('#user-tips-nr').html(strpad(storico['tot_consigli'],2,'0'));
	}
	
	imageData = permanentStorage.getItem("profileImage"+permanentStorage.getItem("id"));
	if (imageData !== null && imageData != 'false') {
		var userImage = document.getElementById("user-photo");
		userImage.setAttribute('src', imageData);

		imageData = permanentStorage.getItem("profileImageBlured"+permanentStorage.getItem("id"))
		if (imageData == null || imageData == "false" || (imageData==undefined) || imageData.indexOf('home')>=0) {
		  console.log("refreshValoriInGrafica: blured image non trovata");
		 // console.log(imageData);
		  setTimeout(function() { elaboraBluredUserBackground(); }, 1000);
		}
		else {
		 // console.log(imageData);
		  console.log("blured image trovata");
		  $('#user-profile').css("background-image", permanentStorage.getItem('profileImageBlured'+permanentStorage.getItem('id')));
		}
	}
	
	$("#tip-today-icon-clock").hide();
	if (permanentStorage.getItem('reminder_id') !== null) {
      $("#tip-today-icon-clock").show();
	}
}

function stampaInfoOggi(aggiorna_link) {
  console.log("stampa info oggi");
  $('#tip-today').hide();
  $('#task-today').hide();
  $('#today-nothing-text').hide();
  $('#today-nothing-text-text').html('Scopri il consiglio <br>del giorno!');
  
  if (!isPercorsoDefinito()) {
	  $('#today-nothing-text').show();
	  $('#today-nothing-text-text').html('Non hai selezionato<br />un obiettivo.');
	  return;
  }
  
  if (permanentStorage.getItem('dettaglio_oggi')) {
    var dett          = $.parseJSON(permanentStorage.getItem('dettaglio_oggi'));
    var tip_flag      = false;
    var tip_complete  = false;
    var task_flag     = false;
    var task_complete = false;

	is_activity_selected = is_tip_selected = false;
    $.each(dett, function(k, v){
      if(v.stato == 4) {
        switch(v.tipologia_dettaglio) {
          case 'consiglio':
            var data = v.data.split('-');
            var categoriaConsiglio = getCategoryConsiglio(v.tipologia_consiglio, false);
            $('#tip-today-date').html(data[2]+'/'+data[1]+'/'+data[0]);
            $('#tip-today-text').html(v.consiglio);
            $('#tip-today-id').val(v.id_dettaglio);
            $('#layer-home-start-item-tip').removeClass().addClass('list-item tip '+categoriaConsiglio);
            $('#layer-home-tip-grade-category').removeClass().addClass('grade grade-question '+categoriaConsiglio);
            $('#layer-home-tip-grade-question-category').removeClass().addClass('grade grade-question '+categoriaConsiglio);
            $('#layer-home-list-item-action-grade').removeClass().addClass('list-item-action grade '+getCategoryConsiglio(v.tipologia_consiglio, true));

            if(permanentStorage.getItem('reminder_id') === undefined || !permanentStorage.getItem('reminder_id'))
              $("#tip-today-icon-clock").hide();
           else
              $("#tip-today-icon-clock").show();

			$('#layer-home-tip-grade-confirm-category').removeClass().addClass('grade grade-question '+categoriaConsiglio);
            $('#layer-home-tip-selected-x').attr('data-click-to-selector', '#layer-home-start');
            $('#tip-today-selected-text').html(v.consiglio);
            $('#tip-today-selected-title').html('CONSIGLIO DI OGGI');
            $('#layer-home-tip-selected-btn').html('Valuta');
            $('#layer-home-tip-selected-btn').off('click');
            $('#layer-home-tip-selected-btn').addClass('click-to-element'); // così va al grade-tip
            $('#layer-home-tip-selected-share').show();
            $('#layer-home-tip-selected-title').html('Oggi');
            
            $('#layer-home-tip-share-text').html(v.consiglio);
            $('#tip-selected-category').removeClass().addClass('tip selected '+categoriaConsiglio);
            $('#tip-selected-share-category').removeClass().addClass('tip selected '+categoriaConsiglio);
            tip_flag = true;
            $('#tip-today').show();
          break;
          case 'attivita':
            $('#task-today-text').html(v.attivita);
            $('#task-today-id').val(v.id_dettaglio);
            $("#task-today-selected-text").html(v.attivita);
            $("#layer-home-task-share-text").html(v.attivita);
            task_flag = true;
            $('#task-today').show();
          break;
        }
      }
      else {
        switch(v.tipologia_dettaglio) {
          case 'consiglio':
            tip_complete = true;
          break;
          case 'attivita':
            task_complete = true;
          break;
        }
      }
    });
    
    if (tip_flag || tip_complete) {
		is_tip_selected = true;
	}
	
	if (task_flag || task_complete) {
		is_activity_selected = true;
	}
    
    console.log("consiglio selezionato: "+(is_tip_selected ? "true" : "false"));
    console.log("attività selezionata: "+(is_activity_selected ? "true" : "false"));    

    if(task_complete && tip_complete) {
      $('#today-nothing-text-text').html('Consiglio del giorno e<br />consiglio "Tempo Libero" completati.');
    }

    if(!task_flag && !tip_flag)
      $('#today-nothing-text').show();

    if(aggiorna_link)
      aggiornaLinkLista();
  }
}

function stampaConsigli(aggiornaLink) {
  if (!isPercorsoDefinito()) {
    return;
  }
  
  var tipol_perc = permanentStorage.getItem('tipologia_percorso');
  var titolo_consiglio = "CONSIGLIO";
  var tipologie = $.parseJSON(permanentStorage.getItem('tipologie_percorso'));
  for (i=0; i<tipologie.length; i++) {
	  console.log(i+" "+tipol_perc+" "+tipologie[i]['id']);
	  if (tipol_perc == tipologie[i]['id']) {
		  titolo_consiglio = tipologie[i]['descrizione'].toUpperCase();
		  break;
	  }
  }
  permanentStorage.setItem("tipologia_percorso_string", titolo_consiglio);
  
  console.log('stampa 5 consigli');
  cinque_consigli = $.parseJSON(permanentStorage.getItem('cinque_consigli'));
 // console.log(cinque_consigli);
  storico         = $.parseJSON(permanentStorage.getItem('storico'));
 // console.log(storico);
  if (permanentStorage.getItem('dettaglio_oggi') && permanentStorage.getItem('dettaglio_oggi')!='')
	dettaglio_oggi  = $.parseJSON(permanentStorage.getItem('dettaglio_oggi'));
  else
    dettaglio_oggi = new Array();
//  console.log(dettaglio_oggi);

  if (storico.length>0) {
	permanentStorage.setItem('data_inizio', v.data_inizio);
    //permanentStorage.setItem('consigli', Date.UTC(Date.parse(new Date()) - Date.parse(permanentStorage.getItem('data_inizio'))));
    data_inizio = Date.parse(permanentStorage.getItem('data_inizio'));
    //window.alert(data_inizio);
  }

  //5 consigli
  var consigli_5_str = '';
  var count = 1;
  $.each(cinque_consigli, function(k, v) {
	var id = v['id'];
	consigli_5_str += '<div id="layer-home-tip-'+count+'" rel="'+id+'" class="tip '+(count==1 ? 'active' : '')+' '+getCategoryConsiglio(v['tipologia_consiglio'], false)+
					' swipe-to-element" data-swipe-left-to-selector="#layer-home-tip'+(count!=5 ? "-"+(count+1) : 's')+
					'" data-swipe-left-to-animate-class-in="bounceInDown" data-swipe-left-to-animate-class-out="bounceOutLeft"  '+
					'data-swipe-right-to-selector="#layer-home-'+( count==1 ? 'start' : 'tip-'+(count-1) )+'" data-swipe-right-to-animate-class-in="bounceInDown" data-swipe-right-to-animate-class-out="bounceOutRight">'+
						'<div class="tip-header"><a href="index.html#" class="tip-close pull-right click-to-element" data-click-to-selector="#layer-home-start">'+
							'<span class="icomoon icomoon-close"></span></a></div><div class="tip-separator"></div><div class="tip-content">'+
								'<h2>'+titolo_consiglio+'</h2><br /><h4>'+v['consiglio']+'</h4>'+
					'</div></div>';

	count++;
  });
  $('#content_tips').html(consigli_5_str);
  
  console.log('stampo tutti i consigli');
   // popolo la lista dei consigli
  consigli_lista  = $.parseJSON(permanentStorage.getItem('consigli_lista'));
  var tip_str = '';
  var tip_count = 1;
  var categoria_nome = '';
  $.each(consigli_lista, function(k, v) {
    switch(v.tipologia_consiglio) {
      case '4':
        if(categoria_nome != 'Attività fisica')
         tip_count = 1;
        categoria_nome = 'Attività fisica';
      break;
      case '5':
         if(categoria_nome != 'Food &amp; Drink')
	         tip_count = 1;
        categoria_nome = 'Food &amp; Drink';
      break;
      case '6':
         if(categoria_nome != 'Buone Abitudini')
         	tip_count = 1;
        categoria_nome = 'Buone Abitudini';
      break;
    }

	var cut = '';
    if(v['consiglio'].length > 50)
         cut = ' ... ';
	tip_str += '<div id="list-item-'+tip_count+'" class="list-item tip '+getCategoryConsiglio(v.tipologia_consiglio, false)+'">'+
					'<a href="index.html#" class="item-content"'+
								' onclick="$(document).gotoElement(\'#layer-home-tip-selected\', \'\', \'\', true , showConsiglioDaLista('+v['id']+", '"+v['consiglio'].replace(/'/g,"\\'")+"', '" + v['tipologia_consiglio'] + "'));\">"+
						'<div class="item-arrow h2 pull-right">'+
							'<span class="icomoon icomoon-right"></span>'+
						'</div>'+
						'<h4>'+ categoria_nome +' '+tip_count+'</h4>'+
						'<div class="ellipsis"><p>'+v['consiglio']+cut+'</p></div>'+
					'</a>'+
				'</div>';
	tip_count++;
  });
  $('#tip-items').html(tip_str);  

  if (aggiornaLink)
	aggiornaLinkLista();
}

function showConsiglioDaLista(id, testo, tipologia) {
	console.log(id+" <"+testo+"> ");
	$('#layer-home-tip-selected-btn').removeClass('click-to-element');
	$('#layer-home-tip-selected-btn').removeAttr('data-click-to-selector');
	$('#layer-home-tip-selected-btn').removeAttr('data-click-to-overlay');
	$('#layer-home-tip-selected-btn').html('Accetta');
	$('#layer-home-tip-selected-btn').attr('rel', id);
	$('#layer-home-tip-selected-btn').off('click');
	$('#layer-home-tip-selected-btn').on('click', function() {
		accettaConsiglio($('#layer-home-tip-selected-btn').attr('rel'), true);
		$('#layer-home-tip-selected-btn').attr('data-click-to-selector', "#layer-home-tip-grade");
		$('#layer-home-tip-selected-btn').attr('data-click-to-overlay', "true");
		$('#layer-home-tip-selected-btn').html('Valuta');
	});
	
	$('#tip-today-selected-text').html(testo);
	$('#tip-today-selected-title').html(permanentStorage.getItem("tipologia_percorso_string"));
	$('#layer-home-tip-selected-x').attr('data-click-to-selector', '#layer-home-tips');
	$('#tip-selected-category').removeClass().addClass('tip selected '+getCategoryConsiglio(tipologia, false));
	$('#layer-home-tip-selected-share').hide();
	$('#layer-home-tip-selected-title').html('Consiglio');

}

function getCategoryConsiglio(id_tipologia_consiglio, is_action_tip) {
  var base = 'tip-category';
  if (is_action_tip)
	base = 'action-tip-category'
	
  var categoria = '';
  switch(id_tipologia_consiglio) {
    case '4':
      categoria = base+'-sport';
    break;
    case '5':
      categoria = base+'-food-drink';
    break;
    case '6':
      categoria = base+'-good-habits';
    break;
  }
  return categoria;
}


// stato = 'accettato', 'fallito' o 'inattesa'
function registraNuovoStatoCA(tipologia, stato) {
  var id_dettaglio = null;
  var titolo       = '';
  var testo        = '';
  var id_info      = '';
  
  if (stato == 'fallito') {
    titolo = 'NESSUN PROBLEMA!';
    testo = 'Sicuramente domani sarai più motivato e pronto per il prossimo consiglio, non mollare';
  }
  else if (stato == 'completato') {
	titolo = 'CHE TENACIA';
	testo = 'Non è da tutti seguire un consiglio così, fino alla fine. Si vede che sei determinato, dillo ai tuoi amici!';
  }
  // quando cancello/accetto il consiglio di oggi, lo swipe del consiglio in home mi torna centrato (cosi' se ne seleziono un altro non vedo gli strumenti)
  $('#tip-today').removeClass('swipe-left');
      
  if(tipologia == 'consiglio') {
    id_dettaglio = $('#tip-today-id').val();
    id_info = 'tip';
  }
  else if(tipologia == 'attivita') {
    id_dettaglio = $('#task-today-id').val();
    id_info = 'task';
  }

  console.log('action=changedettaglio&'+getUsernamePassword()+'&iddettaglio='+
        id_dettaglio+'&tipologia_dettaglio='+tipologia+'&stato='+stato);

  if (id_dettaglio) {
	start_wait();
	
	setTimeout( function() {  
		$.ajax( baseurl + "actions.php", {
		  type: 'POST',
		  cache: false,
		  async: false,
		  data: 'action=changedettaglio&'+getUsernamePassword()+'&iddettaglio='+
			id_dettaglio+'&tipologia_dettaglio='+tipologia+'&stato='+stato+'&'+getTokenString(),
		})
		.done(function(risp) {
		  risp = $.parseJSON(risp);
		  error = risp.error;
		  successo = risp.success;
		  data = risp.data;

		  // TODO: usa i layer della grafica
		  if(successo == true) {
			// se sto cancellando/concludendo un consiglio, disabilito un eventuale reminder
			if (tipologia == 'consiglio' && stato != 'accettato' && permanentStorage.getItem('reminder_id')) {
				window.plugin.notification.local.cancel(permanentStorage.getItem('reminder_id'), function() {});
				permanentStorage.removeItem('reminder_ora');
				permanentStorage.removeItem('reminder_minuti');
				permanentStorage.removeItem('reminder_id');
				$("#tip-today-icon-clock").hide();
			}
			  
			if (stato != 'inattesa') {
				$('#'+id_info+'-grade-confirm-title').html(titolo);
				$('#'+id_info+'-grade-confirm-text').html(testo);
				getDatiUtenteOggi();
				refreshValoriInGrafica();
				if(stato == 'completato')
					$(document).gotoElement('#layer-home-'+id_info+'-grade-question', '', '', true, '', '');
				else {
					console.log('|=========================== #'+id_info+'-grade-confirm-title');
					console.log(titolo);
					$(document).gotoElement('#layer-home-'+id_info+'-grade-confirm', '', '', true, '', '');
				}
			}
			else {
				getDatiUtenteOggi();
				refreshValoriInGrafica();
				$(document).gotoElement('#layer-home-start');
			}
			
			end_wait();
		  }
		  else {
			getDatiUtenteOggi();
			refreshValoriInGrafica();
			$(document).gotoElement('#layer-home-start');
			end_wait();
		  }
		});
	}, 100);
  }
  
}
    
function logOut() {
	console.log('logout');
	window.localStorage.clear();
	window.localStorage.setItem('prima_volta', 'false');
	window.plugin.notification.local.cancelAll();
	location.reload();
}


/* ================ caricamento foto profilo ================ */
function onPhotoChooseFail(message) {
	//alert('Failed because: ' + message);
	if ($('#profile_hidden').val() == '' || $('#profile_hidden').val()=='false') {
		setTimeout( function() { $(document).gotoElement('#layer-login-photo-upload'); }, 500);
	}
}

function onPhotoChooseSuccess(imageData) {
  var imgNascosta = new Image();

  if (imageData.substring(0,4) != 'data')
	imageData = "data:image/jpeg;base64," + imageData;

  imgNascosta.onload = function() {
	  var w_orig = imgNascosta.width;
	  var h_orig = imgNascosta.height;
	  console.log(w_orig+" x "+h_orig);
	  
	  if (w_orig != h_orig || w_orig*h_orig > 400000) {
		  var minL = Math.min(w_orig, h_orig);
		  var topL = (h_orig == minL) ? 0 : (h_orig-minL)/2;
		  var leftL = (w_orig == minL) ? 0 : (w_orig-minL)/2;
		  
		  var ratio = Math.sqrt(1.0*(minL*minL)/262144);		// la ridimensiono per avere il peso di una 512*512
		  var w_new = parseInt(minL/ratio);
		  var h_new = parseInt(minL/ratio);
		  console.log(ratio+" "+w_new+" "+h_new);
		  
		  var canvas = document.createElement("canvas");
		  canvas.width = 512;
		  canvas.height = 512;
		  var ctx = canvas.getContext("2d");
		  ctx.drawImage(imgNascosta,leftL,topL, minL, minL, 0, 0, 512, 512);
		  
		  imageData = canvas.toDataURL("image/jpeg");
	  }
	  
	  var smallImage = document.getElementById('img_profile');

	  if (imageData.substring(0,4) != 'data')
		imageData = "data:image/jpeg;base64," + imageData;
	  
	  smallImage.src = imageData;
	  permanentStorage.setItem("profileImage"+permanentStorage.getItem("id"), imageData);
	  console.log("profileImage"+permanentStorage.getItem("id")+": "+imageData.substring(0, 30));
	  
	  $('#profile_hidden').val(imageData);
  };
  imgNascosta.src = imageData;
}

function getPhotoFromGallery() {
	navigator.camera.getPicture(onPhotoChooseSuccess, onPhotoChooseFail, {
		quality: 70,
		allowEdit: true,
		destinationType: navigator.camera.DestinationType.DATA_URL,			// FILE_URI, DATA_URL
		sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY			// PHOTOLIBRARY, SAVEDPHOTOALBUM
	});
}

function sendProfileImage(gotoNuovoPercorso) {
	var hidden = $('#profile_hidden').val();
	
	console.log("action=setprofileimage&"+getUsernamePassword()+"&image=xxx&"+getTokenString());
    $.ajax( baseurl+"actions.php", {
      type: 'POST',
      data: "action=setprofileimage&"+getUsernamePassword()+"&image="+encodeURIComponent($('#profile_hidden').val())+"&"+getTokenString(),
      cache: false,
      async: false,
    }).done(function(risp) {
      risp = $.parseJSON(risp);
      data = risp.data;
      if(!risp.success) {
          $(document).gotoPanel("#layer-login-photo-upload .panel-error");
      }
      else if (gotoNuovoPercorso) {
		  listaPercorsi();
		  $('#layer-login-target-goal').addClass("active");
		  $("#layer-login-photo-confirm").removeClass("active");
	  }
    });
}

// -- selettore foto in home

function onPhotoChooseFailHome(message) {
	console.log("nessuna immagine selezionata");
}

function onPhotoChooseSuccessHome(imageData) {
	setTimeout(function() { onPhotoChooseSuccessHomeTimeout(imageData); }, 200);
}

function onPhotoChooseSuccessHomeTimeout(imageData) {
  var imgNascosta = new Image();

  if (imageData.substring(0,4) != 'data')
	imageData = "data:image/jpeg;base64," + imageData;

  imgNascosta.onload = function() {
	  var w_orig = imgNascosta.width;
	  var h_orig = imgNascosta.height;
	  console.log(w_orig+" x "+h_orig);

	  
	  if (w_orig != h_orig || w_orig*h_orig > 400000) {
		  var minL = Math.min(w_orig, h_orig);
		  var topL = (h_orig == minL) ? 0 : (h_orig-minL)/2;
		  var leftL = (w_orig == minL) ? 0 : (w_orig-minL)/2;
		  
		  var ratio = Math.sqrt(1.0*(minL*minL)/262144);		// la ridimensiono per avere il peso di una 512*512
		  var w_new = parseInt(minL/ratio);
		  var h_new = parseInt(minL/ratio);
		  console.log(ratio+" "+w_new+" "+h_new);
		  
		  var canvas = document.createElement("canvas");
		  canvas.width = 512;
		  canvas.height = 512;
		  var ctx = canvas.getContext("2d");
		  console.log(leftL+ " "+topL+ " "+minL);
		  ctx.drawImage(imgNascosta,leftL,topL, minL, minL, 0, 0, 512, 512);
		  
		  imageData = canvas.toDataURL("image/jpeg");
	  }
	  
	  var smallImage = document.getElementById('img_home_profile');

	  if (imageData.substring(0,4) != 'data')
		imageData = "data:image/jpeg;base64," + imageData;
	  
	  smallImage.src = imageData;
	  
	  $('#hidden_home_profile').val(imageData);
	  
	  permanentStorage.setItem("profileImage"+permanentStorage.getItem("id"), imageData);
	  permanentStorage.setItem("profileImageBlured"+permanentStorage.getItem("id"), 'false');
	  
	  var userImage = document.getElementById("user-photo");
	  userImage.setAttribute('src', imageData);
	  
	  sendProfileImageHome();
  };
  imgNascosta.src = imageData;
}


function getPhotoFromGalleryHome() {
	navigator.camera.getPicture(onPhotoChooseSuccessHome, onPhotoChooseFailHome, {
		quality: 70,
		allowEdit: true,
		destinationType: navigator.camera.DestinationType.DATA_URL,			// FILE_URI, DATA_URL
		sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY			// PHOTOLIBRARY, SAVEDPHOTOALBUM
	});
}

function sendProfileImageHome() {
	var hidden = $('#hidden_home_profile').val();
	
	console.log('action=setprofileimage&'+getUsernamePassword()+'&image=xxx&'+getTokenString());
	if (hidden!='') {
		$.ajax( baseurl+"actions.php", {
		  type: 'POST',
		  data: "action=setprofileimage&"+getUsernamePassword()+"&image="+encodeURIComponent(hidden)+"&"+getTokenString(),
		  cache: false,
		  async: false,
		}).done(function(risp) {
		  risp = $.parseJSON(risp);
		  data = risp.data;
		  if(!risp.success) {
			  $(document).gotoPanel("#layer-home-photo-upload .panel-error");
		  }
		  else  {
			  if (hidden.length>4 && hidden.substring(0,4)!='data')
				hidden = "data:image/jpeg;base64," + hidden;
			
			  console.log("sendProfileImageHome: calcolo blur image "+permanentStorage.getItem('id'));
			
			  setTimeout(function() { elaboraBluredUserBackground(); }, 500);
			
			  //$(document).gotoElement('#layer-home-start');
		  }
		});
	}
	else
		$(document).gotoElement('#layer-home-start');
}

/* ================ fine caricamento foto profilo ================ */


function scaricaImmagineUtente() {
	$.ajax( baseurl+"actions.php", {
      type: 'POST',
      data: 'action=getprofileimage&'+getUsernamePassword()+'&'+getTokenString(),
      cache: false,
      async: false,
    }).done(function(risp) {
      risp = $.parseJSON(risp);
      data = risp.data;
      if(risp.success) {
		imageData = data['image'];
		
		if (imageData.length>4 && imageData.substring(0,4)!='data')
			imageData = "data:image/jpeg;base64," + imageData;
		
		permanentStorage.setItem("profileImage"+permanentStorage.getItem("id"), imageData);
		
		var userImage = document.getElementById("user-photo");
        userImage.setAttribute('src', imageData);
		
        console.log("scaricaImmagineUtente: calcolo blured image");
        
        setTimeout(function() { elaboraBluredUserBackground(); }, 1000);
      }
      
    });
}


function elaboraBluredUserBackground() {
	console.log('elaboraBluredUserBackground');
	imageData = permanentStorage.getItem("profileImage"+permanentStorage.getItem("id"));
	$('#user-profile-hidden').css('background-image', 'url(' + imageData + ')');
	$('#user-profile').blurjs({ source: '#user-profile-hidden', radius: 20, overlay: 'rgba(128,128,128,0.6)' });
	// gli diamo il tempo di aggiornare la proprietà, altrimenti ritorna quella di default
	setTimeout( function() {
		permanentStorage.setItem("profileImageBlured"+permanentStorage.getItem("id"), $('#user-profile').css("background-image"));
	}, 500);
	//console.log("profileImageBlured"+permanentStorage.getItem("id"));

}


/* nota: immagine è un link http 
function condividi(testo, soggetto, immagine, link) {
	console.log("CONDIVIDI");
	// message, subject, image and link
	window.plugins.socialsharing.share(testo, soggetto, immagine, link);
}

function condividiImmagineBase64(img_base64, nomefile) {
	window.plugins.socialsharing.share(null, nomefile, img_base64, null);
}


function condividiTwitter(testo, immagine, link){
	window.plugins.socialsharing.shareViaTwitter(testo, null, link);
}


function condividiFacebook(testo, immagine, url) {
	window.plugins.socialsharing.shareViaFacebook(testo, immagine, url,
		function() {console.log('share ok')},
		function(errormsg){alert(errormsg)}
	);
}*/

/* ------------------------------- Condivisione ----------------------------- */
function getTipologia(id) {
	if ($(id).hasClass('tip-category-sport')) {
		return 4;
	}
	if ($(id).hasClass('tip-category-food-drink')) {
		return 5;
	}
	if ($(id).hasClass('tip-category-good-habits')) {
		return 6;
	}
}

function condividiCAFacebook(tipo, grade, tipo_consiglio) {
	condividiCA('fb', tipo, grade, tipo_consiglio);
}

function condividiCATwitter(tipo, grade, tipo_consiglio) {
	condividiCA('tw', tipo, grade, tipo_consiglio);
}

function condividiCA(social, tipo, grade, tipo_consiglio) {	
	console.log(social+" "+tipo+" "+grade+" "+tipo_consiglio);
	consiglio_grade='0';		//azzero...
	
	//console.log(permanentStorage.getItem('dettaglio_oggi'));
	/*if(grade=='0' && permanentStorage.getItem('dettaglio_oggi')) {
		var dett = $.parseJSON(permanentStorage.getItem('dettaglio_oggi'));

		var dettaglio = null;
		$.each(dett, function(k, v){
			//console.log(v);
			if (v.tipologia_dettaglio == tipo) {
				dettaglio = v;
			}
		});
		
		if (dettaglio != null) {
			//creaBase64imgAndShare(social, tipo, (tipo=='consiglio' ? dettaglio.tipologia_consiglio : dettaglio.tipologia_attivita), (tipo=='consiglio' ? dettaglio.consiglio : dettaglio.attivita));
			if (social=='tw') {
				window.plugins.socialsharing.shareViaTwitter(null, null, null,
					function() {console.log('share ok'); badgeSocial(); $(document).gotoElement('#layer-home-start');},
					function(errormsg){alert(errormsg); $(document).gotoElement('#layer-home-start'); }
				);
			}
			else {
				window.plugins.socialsharing.shareViaFacebook(null, null, null,
					function() {console.log('share ok'); badgeSocial(); $(document).gotoElement('#layer-home-start');},
					function(errormsg){alert(errormsg); $(document).gotoElement('#layer-home-start'); }
				);
			}
		}
	}
	else {*/
	
	var descr = new Array();
	descr[0] = 'Anche oggi ho accettato un consiglio! Niente paura… ce la farò!';
	descr[1] = 'Un buon consiglio al giorno… tutti i giorni! È semplice, buono, mi fa bene… e mi piace pure!';
    descr[2] = 'Non sempre i consigli più giusti sono una passeggiatina! A volte sono proprio una passeggiatona! Un po’ più di impegno però non fa mai male ;)';

	
	var link = baseurl+"result.php?a="+(tipo=='attivita' ? 'a'+"&b="+grade : 'c'+"&b="+grade+"&c="+tipo_consiglio);
	
	var imm= "";
	if (tipo=="attivita") imm = "a/a.jpg";
	else imm = "c/"+tipo_consiglio+".jpg";
	
	if (social=='tw') {
		window.plugins.socialsharing.shareViaTwitter(descr[parseInt(grade)], baseurl+"img/share_immagini/"+imm, null,
			function() {console.log('share ok'); badgeSocial(); condivisioneAvvenutaPopup(); },		// $(document).gotoElement('#layer-home-start');
			function(errormsg){ condivisioneFallitaPopup(); }
		);
	}
	else {
		window.plugins.socialsharing.shareViaFacebook(null, null, link,
			function() {console.log('share ok'); badgeSocial(); condivisioneAvvenutaPopup(); },
			function(errormsg) { condivisioneFallitaPopup(); }
		);
	}
	//}
	
}
/*
function stampaTestoMultiline(ctx, testo, x, y, y_step, max_line) {
	var MAX_LINE = max_line;
	var parole = testo.split(' ');
	console.log(parole);
	
	var i=0;
	var curr = "";
	var curr_old = "";
	while (i<parole.length) {
		if (curr_old=="") {
			curr = parole[i];
		} else {
			curr = curr_old+" "+parole[i];
		}
		
		if (curr.length<MAX_LINE) {
			curr_old=curr;
			i++;
			continue;
		}
		
		//ho sforato, stampo curr_old se non è vuoto, altrimenti la parola di adesso va spezzata
		if (curr_old != "") {
			curr = curr_old;
		}
		else { // se è la parola che è troppo lunga, la spezzo
			curr=curr.substring(0,MAX_LINE);
			parole[i] = parole[i].substring(MAX_LINE);
		}
		// i non cambia perchè la uso nella prox riga.
		
		console.log(curr);
		ctx.fillText(curr,x,y); 
		y+=y_step;
		curr_old=curr="";
	}
	
	if (curr!="")
		ctx.fillText(curr,x,y); 
	
	return ctx;
}

function creaBase64imgAndShare(social, tipo, tipologia_consiglio, testo_consiglio) {
	console.log(tipo+" "+tipologia_consiglio+" <"+testo_consiglio+">");
	
	var canvas = document.createElement("canvas");
	canvas.width = 322;
	canvas.height = 430;
	var ctx = canvas.getContext("2d");
	
	var img = new Image();
    img.onload = function(){
		ctx.drawImage(img,0,0);
	
		var titolo = "CONSIGLIO DI OGGI"
		if (tipo=='attivita')
			titolo="ATTIVITÀ DI OGGI";
		var fs = 28;
		ctx.font=fs+"px GothamRnd";
		while (ctx.measureText(titolo).width > 310) {
			fs--;
			ctx.font=fs+"px GothamRnd";
		}
		ctx.textAlign = 'center';
		ctx.fillStyle='#777777';
		ctx.fillText(titolo,161,270); 
		
		ctx.font="14px GothamRnd";
		ctx = stampaTestoMultiline(ctx, testo_consiglio, 161, 310, 23, 40); 
		  
		imageData = canvas.toDataURL("image/jpeg");
		
		if (imageData.length>4 && imageData.substring(0,4)!='data')
			imageData = "data:image/jpeg;base64," + imageData;
		
		if (social=='tw') {
			window.plugins.socialsharing.shareViaTwitter(null, imageData, null,
				function() {console.log('share ok'); badgeSocial(); $(document).gotoElement('#layer-home-start');},
				function(errormsg){alert(errormsg); $(document).gotoElement('#layer-home-start'); }
			);
		}
		else {
			window.plugins.socialsharing.shareViaFacebook(null, imageData, null,
				function() {console.log('share ok'); badgeSocial(); $(document).gotoElement('#layer-home-start');},
				function(errormsg){alert(errormsg); $(document).gotoElement('#layer-home-start'); }
			);
		}
	}
	console.log('img/share-img/'+(tipo=='consiglio' ? 'cons_'+tipologia_consiglio : 'att')+'.png');
	img.src = 'img/share-img/'+(tipo=='consiglio' ? 'cons_'+tipologia_consiglio : 'att')+'.png';
}


*/
var consiglio_grade = '0';

function cambiaTestoValutazioneCA(tipo, risposta) {
    if(risposta == 'no') {
		$('#'+tipo+'-grade-confirm-title').html('CHE TENACIA!');
        $('#'+tipo+'-grade-confirm-text').html('Non è da tutti seguire un consiglio così fino alla fine. Si vede che sei determinato, dillo ai tuoi amici.');
        consiglio_grade = '2';
	}
    if(risposta == 'si') {
        $('#'+tipo+'-grade-confirm-title').html('PERFETTO!');
        $('#'+tipo+'-grade-confirm-text').html('Anche oggi hai seguito un buon consiglio! Fallo sapere ai tuoi amici.');
        consiglio_grade = '1';
    }
}

/*******************************************************************************/

/* notifiche reminder */
function notificaReminder(reminder) {
	console.log("notifica.reminder:"+reminder);
	if(reminder.indexOf('off') == -1) { //'toggle btn ios btn-primary'
		var now = new Date();
		var reminder_date = new Date(now.getFullYear(), now.getMonth(), now.getDate(), $('#placeholder-tip-reminder-hours').html(), $('#placeholder-tip-reminder-minutes').html());
		console.log(reminder_date);
		if(now.getTime() < reminder_date.getTime()) {
			var dettaglio_oggi = $.parseJSON(permanentStorage.getItem('dettaglio_oggi'));
			$.each(dettaglio_oggi, function(k, v) {
				if(v['tipologia_dettaglio'] == 'consiglio') {
					creaNotifica(v['id_dettaglio']+'_reminder', 'Semplice star bene', 'Hai impostato un reminder per quest\’ora! Ricordati il consiglio ;)',
										reminder_date, JSON.stringify({ 'consiglio': '', 'tipo':'reminder' }));
					permanentStorage.setItem('reminder_ora', reminder_date.getHours());
					permanentStorage.setItem('reminder_minuti', strpad(reminder_date.getMinutes(), 2, '0'));
					permanentStorage.setItem('reminder_id', v.id_dettaglio+'_reminder');
					$("#tip-today-icon-clock").show();
					badgeReminder();
				}
			});
		}
	}
	else if (permanentStorage.getItem('reminder_id')) {
		window.plugin.notification.local.cancel(permanentStorage.getItem('reminder_id'), function() {});
		permanentStorage.removeItem('reminder_ora');
		permanentStorage.removeItem('reminder_minuti');
		permanentStorage.removeItem('reminder_id');
		$("#tip-today-icon-clock").hide();
	}
}

/*
function info_classi() {
	alert($('#page-home').attr('class')+"\n"+$('#page-results-badges').attr('class'));
}*/

function setTempoReminder() {
  var now = new Date();
  var ora = parseInt(now.getHours());
  var minuti = parseInt(now.getMinutes());
  
  if (minuti+1 == 60) {
	  ora = (ora + 1) % 24;
  }
  minuti = (minuti+1) % 60;
  minuti = strpad(minuti, 2, '0');
  
  //console.log(permanentStorage.getItem('reminder_ora'));
  if(permanentStorage.getItem('reminder_ora'))
    ora = permanentStorage.getItem('reminder_ora');
  if(permanentStorage.getItem('reminder_minuti'))
    minuti = permanentStorage.getItem('reminder_minuti');
  //console.log('minuti: '+permanentStorage.getItem('reminder_minuti'));
  //console.log('ora: '+permanentStorage.getItem('reminder_ora'));
  $('#placeholder-tip-reminder-hours').html(ora);
  $('#placeholder-tip-reminder-minutes').html(minuti);
  $('#tip-reminder-hours').val(ora);
  $('#tip-reminder-minutes').val(minuti);
}


function stampaStorico() {
	console.log('stampa storico');
	var storico = $.parseJSON( permanentStorage.getItem('storico') );
	var tipologie_percorso = reorganizeArray( $.parseJSON( permanentStorage.getItem('tipologie_percorso') ));
	
	//console.log(storico);
	//console.log(tipologie_percorso);

	var stringa = "";
	//console.log(corrente);
	if (!(storico.corrente==null || storico.corrente==undefined)) {
		corrente = storico.corrente;
		var v1 = 0;
		var v2 = 0;
		var v3 = 0;
		for (idx=0; idx<corrente.dettaglio_consigli.length; idx++) {
		  v = corrente.dettaglio_consigli[idx];
		  if (parseInt(v['tipologia_consiglio']) == 4)	// attivita
			v2 = parseInt(v['tot']);
		  else if (parseInt(v['tipologia_consiglio']) == 5)	// food and drink
			v1 = parseInt(v['tot']);
		  else if (parseInt(v['tipologia_consiglio']) == 6)	// buone abitudini
			v3 = parseInt(v['tot']);
		}
		var v4 = parseInt(corrente['consigli_falliti']);
		
	/*	$('#layer-results-input-share').val(formatNumber(v1+v2+v3, 30));
		$('#layer-results-input-share').attr('data-value-1', formatNumber(v1, 30));
		$('#layer-results-input-share').attr('data-value-2', formatNumber(v2, 30));
		$('#layer-results-input-share').attr('data-value-3', formatNumber(v3, 30));
		$('#layer-results-input-share').attr('data-value-4', formatNumber(v4, 30));
		$('#layer-results-input-selected').val(formatNumber(v1+v2+v3, 30));
		$('#layer-results-input-selected').attr('data-value-1', formatNumber(v1, 30));
		$('#layer-results-input-selected').attr('data-value-2', formatNumber(v2, 30));
		$('#layer-results-input-selected').attr('data-value-3', formatNumber(v3, 30));
		$('#layer-results-input-selected').attr('data-value-4', formatNumber(v4, 30));
		
		$('#layer-results-result-share-content').html("Obiettivo: "+tipologie_percorso[parseInt(corrente['tipologia_percorso'])].descrizione+"<br />In corso: "+days_from_start(corrente['data_inizio'])+"º giorno");
		*/
		stringa = storicoParziale(true, 1, tipologie_percorso[parseInt(corrente['tipologia_percorso'])].descrizione,
						days_from_start(corrente['data_inizio']), 30, v1, v2, v3, v4, corrente['id']);
	}

	altri = storico.altri;
	console.log(altri);
	
	if (!(altri==null || altri==undefined)) {
		i=0;
		while (!(altri[''+i] == undefined || altri[''+i] == null )) {
			altro = altri[i];
			v1 = 0;
			v2 = 0;
			v3 = 0;
			for (idx=0; idx<altro.dettaglio_consigli.length; idx++) {
			  v = altro.dettaglio_consigli[idx];
			  console.log(""+idx+": "+v);
			  if (parseInt(v['tipologia_consiglio']) == 4)	// attivita
				v2 = parseInt(v['tot']);
			  else if (parseInt(v['tipologia_consiglio']) == 5)	// food and drink
				v1 = parseInt(v['tot']);
			  else if (parseInt(v['tipologia_consiglio']) == 6)	// buone abitudini
				v3 = parseInt(v['tot']);

			}
			var daydiff = days_diff(altro['data_inizio'], altro['data_fine']);
			stringa += storicoParziale(false, i+2, tipologie_percorso[parseInt(altro['tipologia_percorso'])].descrizione,
							daydiff, 30, v1, v2, v3, parseInt(altro['consigli_falliti']), altro['id']);
			i++;
		}
	}
	
	
	$('#layer-results-start-list-items').html(stringa);
	
	bindChartInput();
}

function formatNumber(n, d) {
	var num = n*100.0/d;
	
	return Math.round(num);
}

var risultato_da_condividere = 0;
var punteggio = 0;
function caricaCondivisioneRisultati(id, punti) {
	risultato_da_condividere = id;
	punteggio = punti;
	
	
	var testi = new Array();

	testi[0] = 'Diciamo che ti sei distratto un pochino? :D Dai su, con un po\' più di buona volontà scoprirai quant\'è facile e semplice star bene.';
	testi[1] = 'Ok dai, ci hai provato! Certo che qualche consiglio in più, poca attenzione, e magari le sveglie ti avrebbero aiutato. Alla fine sai cosa si dice in queste situazioni no? L\'importante è partecipare!';
	testi[2] = 'Hai sentito gli effetti del programma, vero? Ma chi ha detto che ti devi fermare qui? Continua a usare Semplice Star Bene, poniti un nuovo obiettivo, e tenta di fare sempre meglio! Da qui in poi non si può far altro che migliorare. ';
	testi[3] = 'Sei arrivato fin qua e i risultati si vedono! Ti senti meglio vero? E il tutto senza neanche un piccolo grande sacrificio. È bastato un buon consiglio al giorno tutti i giorni. Non fermarti qui, si può sempre migliorare! Continua e scegli un nuovo obiettivo per il tuo Semplice Star Bene.';
	testi[4] = 'Hai colto in pieno lo spirito del Semplice Star Bene! Ammettilo, stai meglio vero? Visto come un buon consiglio al giorno, tutti i giorni, ti porta lontano senza troppa fatica? Complimenti, davvero! Un consiglio? Adesso scegli un nuovo obiettivo!';
	
	tipo = Math.floor((punteggio*100.0/30)/20);
	console.log(id+" "+ punti+" "+ tipo);
	
	$('#layer-results-result-share-content').html(testi[tipo]);
	
	
	/*$('#layer-results-input-selected').remove();
	$('#layer-results-input-share').remove();
	
	$('#layer-results-result-selected .chart').html('<input id="layer-results-input-selected" data-stopper="false" data-readonly="true" value="'+formatNumber(v1+v2+v3, 30)+'" '+
							'data-value-1="'+formatNumber(v1, 30)+'" data-color-1="#f9dc68" '+
							'data-value-2="'+formatNumber(v2, 30)+'" data-color-2="#ff9191" '+
							'data-value-3="'+formatNumber(v3, 30)+'" data-color-3="#3aedb8" '+
							'data-value-4="'+formatNumber(v4, 30)+'" data-color-4="#cecece">');
	
	$('#layer-results-result-share .chart').html('<input id="layer-results-input-share" data-stopper="false" data-readonly="true" value="'+formatNumber(v1+v2+v3, 30)+'" '+
							'data-value-1="'+formatNumber(v1, 30)+'" data-color-1="#f9dc68" '+
							'data-value-2="'+formatNumber(v2, 30)+'" data-color-2="#ff9191" '+
							'data-value-3="'+formatNumber(v3, 30)+'" data-color-3="#3aedb8" '+
							'data-value-4="'+formatNumber(v4, 30)+'" data-color-4="#cecece">');
	
	$('#layer-results-result-share-content').html("Obiettivo: "+obiettivo+"<br />Consigli completati: "+(v1+v2+v3));
	
	bindChartInput();*/
}

function storicoParziale(isCurrent, idx, obiettivo, giorni, max_giorni, v1, v2, v3, v4, id) {
	console.log('storicoParziale('+isCurrent+', '+idx+', '+obiettivo+', '+giorni+', '+v1+', '+v2+', '+v3+', '+v4+')');
	var stringa = '<div class="list-item-result '+(isCurrent ? 'active" id="grafico-risultati-attivo' : '')+'">' + "\n" +
						'<div class="list-item-wrap target">' + "\n" +

							'<div class="list-item">' + "\n" +
								'<div class="item-content">' + "\n" +
									'<h4>Obiettivo: <span class="placeholder-target-goal">'+obiettivo+'</span></h4>' + "\n" +
									'<h4 class="target-status">'+ (isCurrent ? 'In corso: <span class="placeholder-target-days">'+giorni+'&deg; giorno</span>'
																	: 'Concluso: <span class="placeholder-target-days">'+giorni+'&deg; giorno</span>')+'</h4>' + "\n" +
								'</div>' + "\n" +
							'</div>' + "\n" +
							(!isCurrent ?
							'<div class="list-item-action share">' + "\n" +
								'<a href="index.html#" class="h2 click-to-element" data-click-to-selector="#layer-results-result-share" data-click-to-overlay="true" '+
										'onclick="caricaCondivisioneRisultati('+id+', '+(v1+v2+v3)+');">' + "\n" +
									'<span class="icomoon icomoon-share"></span>' + "\n" +
								'</a>' + "\n" +
							'</div>' + "\n" : "") +
						   (isCurrent ?
							'<div class="list-item-action trash">' + "\n" +
								'<a href="index.html#" class="h2 click-to-element" data-click-to-selector="#layer-results-result-delete" data-click-to-overlay="true">' + "\n" +
									'<span class="icomoon icomoon-delete"></span>' + "\n" +
								'</a>' + "\n" +
							'</div>' + "\n" : "") +
						'</div>' + "\n" +

						'<div class="list-item-wrap chart">' + "\n" +
							'<div class="list-item">' + "\n" +
								'<input data-stopper="false" data-readonly="true" value="'+formatNumber(v1+v2+v3,max_giorni)+'"' + "\n" +
									'data-value-1="'+formatNumber(v1,max_giorni)+'" data-color-1="#f9dc68"' + "\n" +
									'data-value-2="'+formatNumber(v2,max_giorni)+'" data-color-2="#ff9191"' + "\n" +
									'data-value-3="'+formatNumber(v3,max_giorni)+'" data-color-3="#3aedb8"' + "\n" +
									'data-value-4="'+formatNumber(v4,max_giorni)+'" data-color-4="#cecece" >' + "\n" +
							'</div>' + "\n" +
						'</div>' + "\n" +

						'<div class="list-item-wrap status">' + "\n" +
							'<div class="list-item">' + "\n" +
								'<a href="index.html#result-status-'+idx+'" class="group-content" data-toggle="collapse">' + "\n" +
									'<h4>Consigli completati: <span class="placeholder-tips-done">'+(v1+v2+v3)+'</span> su <span class="placeholder-tips-all">'+max_giorni+'</span>' + "\n" +
										'<span class="group-arrow"> <span class="icomoon icomoon-down"></span> </span></h4>' + "\n" +
								'</a>' + "\n" +
								'<div id="result-status-'+idx+'" class="collapse text-left">' + "\n" +
									'<ul class="list-unstyled">' + "\n" +
										'<li><span class="dot dot-category-food-drink"></span><span class="placeholder-tips-category-food-drink">'+v1+'</span> Consigli food & drink</li>' + "\n" +
										'<li><span class="dot dot-category-sport"></span><span class="placeholder-tips-category-food-drink">'+v2+'</span> Consigli attività fisica</li>' + "\n" +
										'<li><span class="dot dot-category-good-habits"></span><span class="placeholder-tips-category-food-drink">'+v3+'</span> Consigli buone abitudini</li>' + "\n" +
										'<li><span class="dot dot-category-"></span><span class="placeholder-tips-category-food-drink">'+v4+'</span> Consigli non completati</li>' + "\n" +
									'</ul>' + "\n" +
								'</div>' + "\n" +
							'</div>' + "\n" +
						'</div>' + "\n" +
					'</div>' +"\n\n";

	return stringa;
}

function showContinuaToPercorso(flag) {
	var cont='none', two='block';
	if (flag) {
		cont = 'block';
		two = 'none';
	}

	$("#results-footer-continue-1").css('display', cont);
	$("#results-footer-continue-2").css('display', cont);
	$("#results-footer-two-1").css('display', two);
	$("#results-footer-two-2").css('display', two);
}

function terminaPercorso() {
	console.log('termina percorso: action=chiudipercorsoattivo&'+getUsernamePassword());
	$.ajax( baseurl+"actions.php", {
      type: 'POST',
      data: 'action=chiudipercorsoattivo&'+getUsernamePassword()+'&'+getTokenString(),
      cache: false,
      async: false
    }).done(function(risp) {
	  console.log(risp);
      risp = $.parseJSON(risp);
      if (risp.success) {
		var vecchio_id_perc = permanentStorage.getItem('id_percorso');
		var vecchio_storico = $.parseJSON( permanentStorage.getItem('storico') );
		vecchio_storico = vecchio_storico['corrente'];
		
		$('#grafico-risultati-attivo').removeClass('active');
		permanentStorage.removeItem('id_percorso');
		permanentStorage.removeItem('dettaglio_oggi');
		permanentStorage.removeItem('cinque_consigli');
		
		window.plugin.notification.local.cancelAll();
		permanentStorage.removeItem('reminder_ora');
		permanentStorage.removeItem('reminder_minuti');
		permanentStorage.removeItem('reminder_id');
		
		getDatiUtenteOggi();
		refreshValoriInGrafica();
		
		showContinuaToPercorso(true);
		
		caricaCondivisioneRisultati(vecchio_id_perc, vecchio_storico['tot_consigli']);
		$(document).gotoElement('#layer-results-result-selected', '', '', true, '', '');
		
		showContinuaToPercorso(true);
      }
      
    });
}

function onclickPulsanteReminder() {
	$('#placeholder-tip-reminder-hours').html($('#swiper-tip-reminder-hours > .swiper-wrapper > .swiper-slide-active > .content-slide').html());
	$('#placeholder-tip-reminder-minutes').html($('#swiper-tip-reminder-minutes > .swiper-wrapper > .swiper-slide-active > .content-slide').html());
	$('#reminder-active > .toggle.btn.btn-default.off.ios').removeClass().addClass('toggle btn ios btn-primary');
}

function closeCondivisioneConsiglio() {
	if (is_valutazione_consiglio) {
		/*$('.page.active').removeClass('active');
		$('.layer.active').removeClass('active');
		$('#page-results-badges').removeClass('active').addClass('active');
		$('#layer-results-start').removeClass('active').addClass('active');*/
		$(document).gotoElement('#page-results-badges');
		setTimeout( function() { $(document).gotoElement('#layer-results-start'); }, 300);
	}
	else {
		$(document).gotoElement('#layer-home-start');
	}
	is_valutazione_consiglio = false;
}

function preload_wait() {
	$('#spinner').spin({
		lines: 15, // The number of lines to draw
		length: 0, // The length of each line
		width: 8, // The line thickness
		radius: 30, // The radius of the inner circle
		corners: 1, // Corner roundness (0..1)
		rotate: 0, // The rotation offset
		direction: 1, // 1: clockwise, -1: counterclockwise
		color: '#fff', // #rgb or #rrggbb or array of colors
		speed: 1, // Rounds per second
		trail: 60, // Afterglow percentage
		shadow: true, // Whether to render a shadow
		hwaccel: false, // Whether to use hardware acceleration
		className: 'spinner', // The CSS class to assign to the spinner
		zIndex: 2e9, // The z-index (defaults to 2000000000)
		top: '50%', // Top position relative to parent
		left: '50%' // Left position relative to parent
	});
}

var is_wait_active = false;

function start_wait() {
	if (is_wait_active) return;
	
	// Sticky
	$(document).toggleSticky('#spinner');
	is_wait_active = true;
	console.log("WAIT ACTIVE");
}

function end_wait() {
	if (!is_wait_active) return;
	
	$(document).toggleSticky('#spinner');
	is_wait_active = false;
	console.log("WAIT HIDDEN");
}
